#include "battle_interface\log_msg.h"

#define LOG_FOR_SEA		1
#define LOG_FOR_LAND	2

object showWindow;

object IActions, ILog, IDateTimeDisplay; // KK

object IBoardingStatus;
bool   bYesBoardStatus;
string g_ActiveActionName;

//bool bEternalString = false; // KK
string sDateTimeDisplay = ""; // KK

bool bHourBellPlayed=false; // HKE
bool bAiupdated = false; // Screwface

bool bIslandChecked=false;	// LDH 07Jan09

#event_handler("blieGetMsgIconRoot","BI_GetMsgIconRoot");
#event_handler("evntUpdateTime", "procUpdateTime");

void InitLogInterface()
{
	SetEventHandler("SetWindowSize","LI_SetWindowSize",0);
	CreateEntity(&IActions,"ActionIntrface");
	CreateEntity(&ILog, "ILogAndActions"); // KK
	DelEventHandler("SetWindowSize","LI_SetWindowSize");
	DeleteAttribute(&IActions,"");
	DeleteAttribute(&ILog, ""); // KK
	CreateLogEnvironment();
// --> KK
	//SendMessage(&IActions,"lll",LOG_AND_ACTIONS_INIT,sti(InterfaceStates.BattleShow.FastCommand),sti(InterfaceStates.BattleShow.ActionLabel));
	//SendMessage(&ILog,"lll",LOG_AND_ACTIONS_INIT,sti(InterfaceStates.BattleShow.FastCommand),sti(InterfaceStates.BattleShow.LogString));
// <-- KK
	SetEventHandler(EVENT_LOCATION_LOAD,"LI_LocationLoad",0);
	SetEventHandler("BI_FastCommand","BI_FastCommand",0);
	SetEventHandler(BI_EVENT_SET_VISIBLE,"SetLogInterfaceVisible",0);
// KK -->
	LayerAddObject("execute", &ILog, -257);
	LayerAddObject("realize", &ILog, -257);
	LayerAddObject(SEA_EXECUTE, &ILog,-257);
	LayerAddObject(SEA_REALIZE, &ILog, -257);
	LayerAddObject("execute", &IActions, -257);
	LayerAddObject("realize", &IActions, -257);
	LayerAddObject(SEA_EXECUTE, &IActions, -257);
	LayerAddObject(SEA_REALIZE, &IActions, -257);
// <-- KK
	InitActivePerkShower();
}

void LI_SetWindowSize()
{
	int w = GetEventData();
	int h = GetEventData();
	int bTVused = GetEventData();
	if(bTVused)	SetShowWindowParameters(bTVused,w,h,40,24,w-40,h-24);
	else	SetShowWindowParameters(bTVused,w,h,0,0,w,h);
}

void SetLogInterfaceVisible()
{
	int visibleFlag = GetEventData();
	ILog.visible = visibleFlag; // KK
	SendMessage(&ILog,"ll",LI_SET_VISIBLE,visibleFlag);
}

// KK -->
void LogVisible(bool visibleFlag)
{
	ILog.visible = visibleFlag;
	SendMessage(&ILog, "ll", LI_SET_VISIBLE, visibleFlag);
}

void ActionsVisible(bool visibleFlag)
{
	IActions.visible = visibleFlag;
	SendMessage(&IActions, "ll", LI_SET_VISIBLE, visibleFlag);
}

void DateTimeVisible(bool visibleFlag)
{
	IDateTimeDisplay.visible = visibleFlag;
	SendMessage(&IDateTimeDisplay, "ll", LI_SET_VISIBLE, visibleFlag);
}

void LogsVisible(bool visibleFlag)
{
	ActionsVisible(visibleFlag);
	LogVisible(visibleFlag);
	if (isEntity(&IDateTimeDisplay)) DateTimeVisible(visibleFlag);
}

void SwapActionsAndLog(bool visibleFlag)
{
	ActionsVisible(visibleFlag);
	LogVisible(!visibleFlag);
}

bool IsActionsVisible()
{
	ref rtmp;
	makeref(rtmp, IActions);
	if (!CheckAttribute(rtmp, "visible")) rtmp.visible = false;
	return sti(rtmp.visible);
}

bool IsLogVisible()
{
	ref rtmp;
	makeref(rtmp, ILog);
	if (!CheckAttribute(rtmp, "visible")) rtmp.visible = false;
	return sti(rtmp.visible);
}
// <-- KK

void LI_LocationLoad()
{
	InitDateTimeDisplay(); // KK
	CreateILogAndActions(LOG_FOR_LAND);
}

void InitBattleInterfacesParameters()
{
	DeleteClass(&IBoardingStatus);
	DeleteAttribute(&IBoardingStatus,"");
	bYesBoardStatus = false;
}

void CreateILogAndActions(int loadType)
{
	DeleteAttribute(&IBoardingStatus,"ActiveActions");
	if(loadType==LOG_FOR_SEA)
	{
		CreateSeaActionsEnvironment();
	}
	if(loadType==LOG_FOR_LAND)
	{
		CreateLandActionsEnvironment();
	}
// KK -->
	ref rLog; makeref(rLog, ILog);
	DeleteAttribute(rLog, "");
	CopyAttributes(rLog, &IActions);
	IActions.Log.up = sti(showWindow.top) + RecalculateVIcon(sti(IActions.ActiveActions.height)) + RecalculateVIcon(16);
	IActions.Log.left = sti(showWindow.left) + RecalculateHIcon(16);
	IActions.Log.color = argb(0,255,255,255);	// LDH 19Jan09
	SendMessage(&IActions,"lll",LOG_AND_ACTIONS_INIT,sti(InterfaceStates.BattleShow.FastCommand),sti(InterfaceStates.BattleShow.ActionLabel));
	SendMessage(&ILog,"lll",LOG_AND_ACTIONS_INIT,false,sti(InterfaceStates.BattleShow.LogString));

	if (isEntity(&IDateTimeDisplay)) CreateDateTimeDisplay();
// <-- KK
	Log_SetActiveAction(g_ActiveActionName);
}

void Log_SetActiveAction(string actionName)
{
// KK -->
	if (actionName == "Reload" && GetReloadMapAttrib(FindLoadedLocation(), chrWaitReloadLocator, "go") == "") return;
	if (actionName == "Nothing") {
		SendMessage(&IActions, "l", LI_CLEAR_STRINGS);
		ILog.Log.up = sti(ILog.Log.org.up);
	} else {
		ILog.Log.up =  sti(showWindow.top) + RecalculateVIcon(sti(IActions.Log.up)) + 32;
	}
// <-- KK
	SendMessage(&ILog,"lll",LOG_AND_ACTIONS_INIT,sti(InterfaceStates.BattleShow.FastCommand),sti(InterfaceStates.BattleShow.LogString));
	g_ActiveActionName = actionName;
	SendMessage(&IActions,"ls",LOG_SET_ACTIVE_ACTION,actionName);
	if (TRACEALLLOGS == 1) Trace("Log - SetActiveAction: " + actionName);
}

// KK -->
void Log_SetActionLabel(string label)
{
	SendMessage(&IActions, "l", LI_CLEAR_STRINGS);
	if (label == "") return;
	SendMessage(&IActions, "lls", LOG_ADD_STRING, true, label);
}
// <-- KK

void Log_SetStringToLog(string strLog)
{
	SendMessage(&ILog,"lls",LOG_ADD_STRING, false, strLog);
  if (TRACEALLLOGS == 1)
  {
		Trace("Log - SetStringToLog: " + strLog);
  }
}

/*void Log_SetStringToLog(string strLog)
{//MAXIMUS: will store log-strings while player is on reload-locator, or speaks with NPC, or near some box. All logs will be shown later.
	aref refStrings;
	if(chrWaitReloadLocator!="" || CheckAttribute(GetMainCharacter(),"Interlocutor.update") || CheckAttribute(GetMainCharacter(),"BoxName.update"))
	{
		makearef(refStrings,IActions.storedstrings);
		string newStr = "str"+GetAttributesNum(refStrings);
		refStrings.(newStr) = strLog;
		return;
	}
	else
	{
		makearef(refStrings,IActions.storedstrings);
		if(GetAttributesNum(refStrings)>0)
		{
			int num = GetAttributesNum(refStrings);
			for(int i=0; i<num; i++)
			{
				string strData = "str"+i;
				if(CheckAttribute(refStrings,strData))
				{
					SendMessage(&IActions,"lls",LOG_ADD_STRING, false, refStrings.(strData));
					DeleteAttribute(refStrings,strData);
				}
			}
		}
		DeleteAttribute(&IActions,"storedstrings");
	}
	SendMessage(&IActions,"lls",LOG_ADD_STRING, false, strLog);
	if (TRACEALLLOGS == 1) Trace("Log - SetStringToLog: " + strLog);
}*/

void Log_SetEternalString(string strLog)
{
	SendMessage(&ILog,"lls",LOG_ADD_STRING, true, strLog);
	if (TRACEALLLOGS == 1) Trace("Log - SetEternalString: " + strLog);
}

void CreateLogEnvironment()
{
	//  CCC Make log message smaller and relocate  -->
	ILog.Log.width = sti(showWindow.sw)/2;
	ILog.Log.height = sti(showWindow.sh)-80;
	ILog.Log.left = sti(showWindow.left)+1; // ccc maptweak original value +88
	ILog.Log.up = sti(showWindow.top)+1; //+16
	ILog.Log.font = "interface_small"; // interface_normal
	ILog.Log.color = argb(0,255,255,255);
	ILog.Log.offsetString = 14; //24
	ILog.Log.speed = 0.1; //0.05		// LDH this is the scroll speed after the log fades - 03Jan09
	ILog.Log.color_speed = 0.01; //0.02	// LDH this is the speed at which the log fades - 03Jan09
	// NOTE: The last two lines determine how fast the message disappears and scrolls. If you want to change this: INCREASING the values makes it vanish FASTER
//  <--  CCC Make log message smaller and relocate
// KK -->
	ILog.Log.org.up = sti(ILog.Log.up);

	ref rActions;
	makeref(rActions, IActions);
	DeleteAttribute(rActions, "");
	CopyAttributes(rActions, &ILog);
// <-- KK
}

void CreateSeaActionsEnvironment()
{
	IActions.ActiveActions.TextureName = "battle_interface\cicons_command.tga";
	IActions.ActiveActions.horzQ = 8;
	IActions.ActiveActions.vertQ = 8; // FCoHS
	IActions.ActiveActions.width = RecalculateHIcon(64);
	IActions.ActiveActions.height = RecalculateVIcon(64);
	IActions.ActiveActions.left = sti(showWindow.left)+16;
	IActions.ActiveActions.top = sti(showWindow.top)+16;

	IActions.ActiveActions.Moor.IconNum		= 1;
	IActions.ActiveActions.Board.IconNum		= 2;
	IActions.ActiveActions.LandTroops.IconNum	= 8;
	IActions.ActiveActions.Map.IconNum		= 9;
	IActions.ActiveActions.Transfer.IconNum		= 10;
	IActions.ActiveActions.EnterFort.IconNum = 0; // KK
	IActions.ActiveActions.Nothing.IconNum	= -1;
}

void CreateLandActionsEnvironment()
{
	ref PChar = GetMainCharacter();		//JRH

	IActions.ActiveActions.TextureName = "battle_interface\land_fast_commands.tga";
	IActions.ActiveActions.horzQ = 8;
	IActions.ActiveActions.vertQ = 8; // KK // MAXIMUS
	IActions.ActiveActions.width = RecalculateHIcon(64);
	IActions.ActiveActions.height = RecalculateVIcon(64);
	IActions.ActiveActions.left = sti(showWindow.left)+16;
	IActions.ActiveActions.top = sti(showWindow.top)+16;

// MAXIMUS & KK -->
	IActions.ActiveActions.Nothing.IconNum			= -1;
	IActions.ActiveActions.Closed.IconNum				= 0;
	IActions.ActiveActions.Reload.IconNum				= 1;
	IActions.ActiveActions.ToAcademy.IconNum			= 1;
	// KK IActions.ActiveActions.OpenBox.IconNum		= 2;
	IActions.ActiveActions.Action.IconNum				= 2;
	IActions.ActiveActions.Pick.IconNum				= 2;
	IActions.ActiveActions.Look.IconNum				= 3;
	IActions.ActiveActions.Talk.IconNum				= 4;
	IActions.ActiveActions.ToBoat.IconNum				= 5;
	IActions.ActiveActions.OpenWeaponsLocker.IconNum	= 6;
	IActions.ActiveActions.ToArsenal.IconNum			= 6;
	IActions.ActiveActions.OpenBarrel.IconNum			= 7;
	IActions.ActiveActions.ToStore.IconNum			= 8;
	IActions.ActiveActions.ToShipyard.IconNum			= 9;
	IActions.ActiveActions.ToTavern.IconNum			= 10;
	IActions.ActiveActions.ToResidence.IconNum		= 11;
	IActions.ActiveActions.ToUsurer.IconNum			= 12;
	IActions.ActiveActions.ToChurch.IconNum			= 13;
	IActions.ActiveActions.ToTailor.IconNum			= 14;
	IActions.ActiveActions.ToBlacksmith.IconNum		= 15;
	IActions.ActiveActions.ToPrison.IconNum			= 16;
	IActions.ActiveActions.ToFort.IconNum				= 17;
	IActions.ActiveActions.ToBrothel.IconNum			= 18;
	IActions.ActiveActions.ToShipDeck.IconNum			= 19;
	IActions.ActiveActions.ToCabin.IconNum			= 20;
	IActions.ActiveActions.ToSeaDogs.IconNum			= 21;
	IActions.ActiveActions.ToCannonsDeck.IconNum		= 22;
	IActions.ActiveActions.ToCargoHold.IconNum		= 23;
	IActions.ActiveActions.ToFightDeck.IconNum		= 24;
	IActions.ActiveActions.ToPort.IconNum				= 25;
	IActions.ActiveActions.ToSea.IconNum				= 26;
	IActions.ActiveActions.ToTown.IconNum				= 27;
	IActions.ActiveActions.ToJungle.IconNum			= 28;
	IActions.ActiveActions.OpenBox.IconNum			= 29;
	IActions.ActiveActions.Corpse.IconNum				= 30;
	IActions.ActiveActions.Idol.IconNum				= 31;
	IActions.ActiveActions.ToShore.IconNum			= 32;//MAXIMUS
	IActions.ActiveActions.TalkWith.IconNum			= 4;//MAXIMUS
	IActions.ActiveActions.ToMap.IconNum			= 33; // KK
//JRH -->
	if(GetStoryline(FindCurrentStoryline()) == "Bartolomeu")
   	{
	    if( CheckAttribute(Pchar,"boxname") )
	    {
			IActions.ActiveActions.OpenBox.IconNum					 	= 29;
		//Cartagena -->
			if(Pchar.location == "Governor_Daughter_House")	
			{
				if(Pchar.boxname == "box2")
				{
					if(CheckCharacterItem(Pchar,"bladefire_irons"))
					{
						IActions.ActiveActions.OpenBox.IconNum  		= 2;	
					}
					else IActions.ActiveActions.OpenBox.IconNum  			= 3;
				}
			}

			if(Pchar.location == "Admiral_office")	
			{
				if(Pchar.boxname == "box1")
				{
					if(CheckCharacterItem(Pchar,"bladecannon_ball"))
					{
						IActions.ActiveActions.OpenBox.IconNum  		= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum 			= 63;
				}

				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum 	= 63;

				if(Pchar.boxname == "box3")
				{
					if(CheckAttribute(Pchar,"quest.admiral_clock") && Pchar.quest.admiral_clock == "off")
					{
						IActions.ActiveActions.OpenBox.IconNum 			= 2;
					}
					else
					{
						if(CheckAttribute(Pchar,"quest.admiral_clock") && Pchar.quest.admiral_clock == "on")
							IActions.ActiveActions.OpenBox.IconNum 		= 55;
					}
					else
					{
						if(CheckCharacterItem(Pchar,"bladeclockkey"))
						{
							IActions.ActiveActions.OpenBox.IconNum 		= 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum 		= 55;
					}
				}

				if(Pchar.boxname == "box4")
				{
					if(CheckAttribute(Pchar,"quest.admiral_lever"))  
					{
						if(Pchar.quest.admiral_lever == "down" || Pchar.quest.admiral_lever == "up")
						{
							IActions.ActiveActions.OpenBox.IconNum  	= 2;
						}
					}
					else
					{
						if(CheckCharacterItem(Pchar,"bladelever"))
						{
							IActions.ActiveActions.OpenBox.IconNum  = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum  	= 3;
					}					
				}

				if(Pchar.boxname == "box5") IActions.ActiveActions.OpenBox.IconNum 	= 2;
			}   
		//<-- Cartagena
	   }
	}

	if(GetStoryline(FindCurrentStoryline()) == "WoodesRogers")
   	{
	    if( CheckAttribute(Pchar,"boxname") )
	    {
			IActions.ActiveActions.OpenBox.IconNum					 	= 29;

			if(Pchar.location == "mutiny_deck")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum  	= 63;
				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum  	= 5;
			}

			if(Pchar.location == "swamp_island1")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3"
				|| Pchar.boxname == "box12")
					{IActions.ActiveActions.OpenBox.IconNum	= 3;}
				if( Pchar.boxname == "box4" || Pchar.boxname == "box5" || Pchar.boxname == "box6"
				|| Pchar.boxname == "box11")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
				if(Pchar.boxname == "box7" || Pchar.boxname == "box8" || Pchar.boxname == "box10")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box9") IActions.ActiveActions.OpenBox.IconNum  	= 5;
			}

			if(Pchar.location == "swamp_island2")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3" || Pchar.boxname == "box4"
				|| Pchar.boxname == "box11" || Pchar.boxname == "box12" || Pchar.boxname == "box13" || Pchar.boxname == "box14"
				|| Pchar.boxname == "box15" || Pchar.boxname == "box18")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
				if(Pchar.boxname == "box5" || Pchar.boxname == "box6")
					{IActions.ActiveActions.OpenBox.IconNum	= 61;}
				if( Pchar.boxname == "box7" || Pchar.boxname == "box8" || Pchar.boxname == "box9"
				|| Pchar.boxname == "box10" || Pchar.boxname == "box17")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box16") IActions.ActiveActions.OpenBox.IconNum  	= 3;
				if(Pchar.boxname == "box19") IActions.ActiveActions.OpenBox.IconNum  	= 5;
			}

			if(Pchar.location == "swamp_wreck_inside")
			{
				if(Pchar.boxname == "box4" || Pchar.boxname == "box5")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
			}

			if(Pchar.location == "Swamp_grot") IActions.ActiveActions.OpenBox.IconNum   	= 30;

			if(Pchar.location == "QC_town")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3" || Pchar.boxname == "box4"
				|| Pchar.boxname == "box5" || Pchar.boxname == "box6" || Pchar.boxname == "box8")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
				if(Pchar.boxname == "box7") IActions.ActiveActions.OpenBox.IconNum  	= 1;
			}

			if(Pchar.location == "QC_store_JRH")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
			}

			if(Pchar.location == "QC_shipyard2_JRH")
			{
				if(Pchar.boxname == "box2")
				{
					if(CheckAttribute(Pchar,"quest.shya_box2") && Pchar.quest.shya_box2 == "open")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 29;
					}
					else
					{
						if(CheckAttribute(Pchar,"quest.shya_box2") && Pchar.quest.shya_box2 == "unlocked_but_stuck")
						{
							if(IsEquipCharacterByItem(Pchar, "tool3"))
							{
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
							else IActions.ActiveActions.OpenBox.IconNum    = 1;
						}
						else
						{
							if(CheckCharacterItem(Pchar,"key2"))
							{
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
							else IActions.ActiveActions.OpenBox.IconNum    = 29;
						}
					}
				}

				if(Pchar.boxname == "box3")
				{
					if(CheckAttribute(Pchar,"quest.shya_posE"))
					{
						if(Pchar.quest.shya_posE == "chest")
						{
							if(CheckAttribute(Pchar,"quest.shya_box3") && Pchar.quest.shya_box3 == "free_key")
							{
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
							else
							{
								if(CheckAttribute(Pchar,"quest.shya_box3") && Pchar.quest.shya_box3 == "open")
								{
									IActions.ActiveActions.OpenBox.IconNum    = 29;
								}
							}
							else
							{
								if(CheckCharacterItem(Pchar,"key4"))
								{
									IActions.ActiveActions.OpenBox.IconNum    = 2;
								}
								else IActions.ActiveActions.OpenBox.IconNum    = 29;
							}
						}
					}
				}

				if(Pchar.boxname == "box4") IActions.ActiveActions.OpenBox.IconNum    = 2;

				if(Pchar.boxname == "box5")
				{
					if(CheckAttribute(Pchar,"quest.shya_box5") && Pchar.quest.shya_box5 == "open")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 29;
					}
					else
					{
						if(CheckCharacterItem(Pchar,"key1"))
						{
							IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 29;
					}
				}

				if(Pchar.boxname == "box6")
				{
					if(CheckAttribute(Pchar,"quest.shya_box6") && Pchar.quest.shya_box6 == "open")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 29;
					}
					else
					{
						if(IsEquipCharacterByItem(Pchar, "blade4"))
						{
							IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 29;
					}
				}

				if(Pchar.boxname == "box7")
				{
					if(CheckAttribute(Pchar,"quest.shya_posJ") && Pchar.quest.shya_posJ == "blocked")
					{
						if(IsEquipCharacterByItem(Pchar, "tool2"))
						{
							IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 3;
					}
				}

				if(Pchar.boxname == "box9")
				{
					if(CheckAttribute(Pchar,"quest.shya_beam"))
					{
						if(Pchar.quest.shya_beam == "middle")
						{
							if(CheckAttribute(Pchar,"quest.shya_barrel2") && Pchar.quest.shya_barrel2 == "taken")
							{
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
							else IActions.ActiveActions.OpenBox.IconNum    = 3;
						}
					}
				}

				if(Pchar.boxname == "box10") IActions.ActiveActions.OpenBox.IconNum    = 2;

				if(Pchar.boxname == "box11")
				{
					if(CheckAttribute(Pchar,"quest.shya_barrel1") && Pchar.quest.shya_barrel1 == "taken")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum    = 3;
				}

				if(Pchar.boxname == "box12")
				{
					if(CheckAttribute(Pchar,"quest.shya_box12") && Pchar.quest.shya_box12 == "unlocked")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 1;
					}
					else
					{
						if(CheckCharacterItem(Pchar,"key3"))
						{
							IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 0;
					}
				}

				if(Pchar.boxname == "box13") IActions.ActiveActions.OpenBox.IconNum    = 2;

				if(Pchar.boxname == "box14")
				{
					if(CheckAttribute(Pchar,"quest.shya_box14") && Pchar.quest.shya_box14 == "free_key")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 2;
					}
					else
					{
						if(CheckAttribute(Pchar,"quest.shya_box14") && Pchar.quest.shya_box14 == "unlocked")
						{
							IActions.ActiveActions.OpenBox.IconNum    = 1;
						}
					}
					else
					{
						if(CheckCharacterItem(Pchar,"key4"))
						{
							IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 0;
					}
				}

				if(Pchar.boxname == "box15")
				{
					if(CheckAttribute(Pchar,"quest.shya_posK") && Pchar.quest.shya_posK == "locked")
					{
						if(IsEquipCharacterByItem(Pchar, "tool1"))
						{
							IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 0;
					}

					if(CheckAttribute(Pchar,"quest.shya_posK") && Pchar.quest.shya_posK == "blocked")
					{
						if(IsEquipCharacterByItem(Pchar, "tool5"))
						{
							IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 2;
					}
				}

				if(Pchar.boxname == "box18")
				{
					if(CheckAttribute(Pchar,"quest.shya_beam"))
					{
						if(Pchar.quest.shya_beam == "left")
						{
							if(CheckAttribute(Pchar,"quest.shya_box9") && Pchar.quest.shya_box9 == "open")
							{
								IActions.ActiveActions.OpenBox.IconNum    = 29;
							}
							else
							{
								if(IsEquipCharacterByItem(Pchar, "blade5"))
								{
									IActions.ActiveActions.OpenBox.IconNum    = 2;
								}
								else IActions.ActiveActions.OpenBox.IconNum    = 3;
							}
						}
					}
				}

				if(Pchar.boxname == "box19")
				{
					if(CheckAttribute(Pchar,"quest.shya_posE"))
					{
						if(Pchar.quest.shya_posE == "blocked")
						{
							if(IsEquipCharacterByItem(Pchar, "tool6"))
							{
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
							else IActions.ActiveActions.OpenBox.IconNum    = 2;
						}
					}
				}
			}

			if(Pchar.location == "Tavern_storeroom")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 2;
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 1;}
			}

			if(Pchar.location == "JRH_tavern_upstairs")
			{
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
			}

			if(Pchar.location == "wr_bedroom")
			{
				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum	= 2;
			}

			if(Pchar.location == "wr_residence")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 62;}
				if(Pchar.boxname == "box4") IActions.ActiveActions.OpenBox.IconNum	= 63;
			}

			if(Pchar.location == "wr_kitchen")
			{
				if(Pchar.boxname == "box4" || Pchar.boxname == "box5")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
			}

			if(Pchar.location == "wr_booty")
			{
				if(Pchar.boxname == "box5") IActions.ActiveActions.OpenBox.IconNum	= 1;
				if(Pchar.boxname == "box4")
				{
					if(CheckAttribute(Pchar,"quest.Friday_room") && Pchar.quest.Friday_room == "open")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
			}

			if(Pchar.location == "wr_armory")
			{
				if(CheckAttribute(Pchar,"boxname") && Pchar.boxname == "box3")
				{
					if(CheckAttribute(Pchar,"quest.wr_quest1"))
					{
						if(Pchar.quest.wr_quest1 == "pistol2" || Pchar.quest.wr_quest1 == "blade_found")
						{
							IActions.ActiveActions.OpenBox.IconNum	= 2;
						}
					}
					return;
				}
			}

			if(Pchar.location == "Redmond_UsurerHouse")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box3" || Pchar.boxname == "box4")
					{IActions.ActiveActions.OpenBox.IconNum	= 1;}
			}

			if(Pchar.location == "wr_gunpowder")
			{
				if(Pchar.boxname == "box3") IActions.ActiveActions.OpenBox.IconNum	= 7;
			}

			if(Pchar.location == "wr_shop")
			{
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box4")
				{
					if(CheckCharacterItem(Pchar,"key8"))
					{
						IActions.ActiveActions.OpenBox.IconNum	= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
			}

			if(Pchar.location == "Redmond_tavern")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2")
					{IActions.ActiveActions.OpenBox.IconNum	= 1;}
			}

			if(Pchar.location == "Dave_Edna_room")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
			}

			if(Pchar.location == "wr_mother")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 2;
			}

			if(Pchar.location == "wr_library")
			{
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3" || Pchar.boxname == "box4" || Pchar.boxname == "box5"
				|| Pchar.boxname == "box6" || Pchar.boxname == "box12" || Pchar.boxname == "box13" || Pchar.boxname == "box7"
				|| Pchar.boxname == "box1" || Pchar.boxname == "box10" || Pchar.boxname == "box11")
					{IActions.ActiveActions.OpenBox.IconNum	= 62;}

				if(Pchar.boxname == "box8" || Pchar.boxname == "box9")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box14")
				{
					if(CheckAttribute(Pchar,"quest.seabattles_enable") && Pchar.quest.seabattles_enable == "yes")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 63;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}

				if(Pchar.boxname == "box15")
				{
					if(CheckAttribute(Pchar,"quest.erotica_enable") && Pchar.quest.erotica_enable == "yes")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 63;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
			}

			if(Pchar.location == "wr_gunroom")
			{
				if( Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3" || Pchar.boxname == "box4")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}

				if(Pchar.boxname == "box5") IActions.ActiveActions.OpenBox.IconNum	= 63;
			}

			if(Pchar.location == "wr_study")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3" || Pchar.boxname == "box4"
				|| Pchar.boxname == "box6")
					{IActions.ActiveActions.OpenBox.IconNum	= 62;}

				if(Pchar.boxname == "box7")
				{
					if(CheckAttribute(Pchar,"quest.study_counter") && Pchar.quest.study_counter == "open")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 29;
					}
					else
					{
						if(CheckCharacterItem(Pchar,"key17"))
						{
							IActions.ActiveActions.OpenBox.IconNum	= 2;
						}
						else
						{
							IActions.ActiveActions.OpenBox.IconNum	= 29;
						}
					}
				}

				if( Pchar.boxname == "box8")
				{
					if(CheckAttribute(Pchar,"quest.study_lever2") && Pchar.quest.study_lever2 == "missing")
					{
						if(CheckCharacterItem(Pchar,"bladelever"))
						{
							IActions.ActiveActions.OpenBox.IconNum	= 2;
						}
						else
						{
							IActions.ActiveActions.OpenBox.IconNum	= 3;
						}
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 2;
				}

				if( Pchar.boxname == "box9")
				{
					if(CheckAttribute(Pchar,"quest.study_lever3") && Pchar.quest.study_lever3 == "missing")
					{
						if(CheckCharacterItem(Pchar,"bladelever"))
						{
							IActions.ActiveActions.OpenBox.IconNum	= 2;
						}
						else
						{
							IActions.ActiveActions.OpenBox.IconNum	= 3;
						}
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 2;
				}

				if( Pchar.boxname == "box10")
				{
					if(CheckAttribute(Pchar,"quest.study_lever1") && Pchar.quest.study_lever1 == "missing")
					{
						if(CheckCharacterItem(Pchar,"bladelever"))
						{
							IActions.ActiveActions.OpenBox.IconNum	= 2;
						}
						else
						{
							IActions.ActiveActions.OpenBox.IconNum	= 3;
						}
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 2;
				}

				if( Pchar.boxname == "box11")
				{
					if(CheckAttribute(Pchar,"quest.study_lever4") && Pchar.quest.study_lever4 == "missing")
					{
						if(CheckCharacterItem(Pchar,"bladelever"))
						{
							IActions.ActiveActions.OpenBox.IconNum	= 2;
						}
						else
						{
							IActions.ActiveActions.OpenBox.IconNum	= 3;
						}
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 2;
				}

				if( Pchar.boxname == "box12" || Pchar.boxname == "box13" || Pchar.boxname == "box14" || Pchar.boxname == "box15")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}

				if(Pchar.boxname == "box16") IActions.ActiveActions.OpenBox.IconNum	= 30;
			}

			if(Pchar.location == "Redmond_town_01")
			{
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box4" || Pchar.boxname == "box5" || Pchar.boxname == "box6" || Pchar.boxname == "box7"
				|| Pchar.boxname == "box8" || Pchar.boxname == "box9" || Pchar.boxname == "box10" || Pchar.boxname == "box11"
				|| Pchar.boxname == "box12")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
			}

			if(Pchar.location == "wr_food_supply")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 10;
				if(Pchar.boxname == "box2" || Pchar.boxname == "box7")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(CheckAttribute(Pchar,"quest.mine_enabled") && Pchar.quest.mine_enabled == "yes")
				{
					if(Pchar.boxname == "box10" || Pchar.boxname == "box11")
						{IActions.ActiveActions.OpenBox.IconNum	= 1;}
				}
				else
				{
					if(Pchar.boxname == "box10" || Pchar.boxname == "box11")
						{IActions.ActiveActions.OpenBox.IconNum	= 0;}
				}

				if(Pchar.boxname == "box12") IActions.ActiveActions.OpenBox.IconNum	= 63;
			}

			if(Pchar.location == "wr_crew")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box5" || Pchar.boxname == "box6")
					{IActions.ActiveActions.OpenBox.IconNum	= 1;}
				if(Pchar.boxname == "box7" || Pchar.boxname == "box8")
					{IActions.ActiveActions.OpenBox.IconNum	= 0;}
			}

			if(Pchar.location == "wr_mine")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
			}

			if(Pchar.location == "wr_mine_control")
			{
				IActions.ActiveActions.OpenBox.IconNum	= 2;
			}

			if(Pchar.location == "wr_prison")
			{
				if(Pchar.boxname == "box3")
				{
					if(CheckCharacterItem(Pchar,"bladepickaxe2"))
					{
						IActions.ActiveActions.OpenBox.IconNum	= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 3;
				}

				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box4"
				|| Pchar.boxname == "box5" || Pchar.boxname == "box7")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box10" || Pchar.boxname == "box11" || Pchar.boxname == "box12")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
				if(Pchar.boxname == "box6")
				{
					if(CheckAttribute(Pchar,"quest.prison_barrel4") && Pchar.quest.prison_barrel4 == "ready_to_remove_plank_from_wall")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 29;
				}
				if(Pchar.boxname == "box8" || Pchar.boxname == "box9")
				{
					if(CheckAttribute(Pchar,"quest.prison_celldoor") && Pchar.quest.prison_celldoor == "open")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
			}

			if(Pchar.location == "wr_gibbet")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 2;
				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum	= 30;

				if(Pchar.boxname == "box3")
				{
					if(CheckCharacterItem(Pchar,"bladesaw"))
					{
						IActions.ActiveActions.OpenBox.IconNum	= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 3;
				}
			}

			if(Pchar.location == "wr_cavern") IActions.ActiveActions.OpenBox.IconNum	= 2;

			if(Pchar.location == "wr_church_inside")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 60;
				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum	= 2;
				if(Pchar.boxname == "box3" || Pchar.boxname == "box4")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
			}

			if(Pchar.location == "wr_church_outside") IActions.ActiveActions.OpenBox.IconNum = 63;

			if(Pchar.location == "wr_church_attic") IActions.ActiveActions.OpenBox.IconNum	= 63;

			if(Pchar.location == "Redmond_shore_02") IActions.ActiveActions.OpenBox.IconNum	= 63;

			if(Pchar.location == "wr_cannon_tower")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 7;
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}

				if(Pchar.boxname == "box5")
				{
					if(CheckAttribute(Pchar,"quest.wt3_musket") && Pchar.quest.wt3_musket == "picked_up")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 3;
				}
			}

			if(Pchar.location == "wr_animists")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3"
				|| Pchar.boxname == "box6")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box16" || Pchar.boxname == "box17")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}
				if(Pchar.boxname == "box9" || Pchar.boxname == "box11" || Pchar.boxname == "box13"
				|| Pchar.boxname == "box15")
					{IActions.ActiveActions.OpenBox.IconNum	= 1;}
				if(Pchar.boxname == "box8")
				{
					if(CheckAttribute(Pchar,"quest.mandala_position") && Pchar.quest.mandala_position == "2")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
				if(Pchar.boxname == "box10")
				{
					if(CheckAttribute(Pchar,"quest.mandala_position") && Pchar.quest.mandala_position == "3")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
				if(Pchar.boxname == "box12")
				{
					if(CheckAttribute(Pchar,"quest.mandala_position") && Pchar.quest.mandala_position == "4")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
				if(Pchar.boxname == "box14")
				{
					if(CheckAttribute(Pchar,"quest.mandala_position") && Pchar.quest.mandala_position == "5")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 0;
				}
			}

			if(Pchar.location == "Shipyard_docks") IActions.ActiveActions.OpenBox.IconNum = 63;

			if(Pchar.location == "defoes_cabin")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3"
				|| Pchar.boxname == "box6")
					{IActions.ActiveActions.OpenBox.IconNum	= 62;}
			}

			if(Pchar.location == "wr_farm_booty")
			{
				if(Pchar.boxname == "box8") IActions.ActiveActions.OpenBox.IconNum	= 2;
			}

			if(Pchar.location == "wr_farm_bedroom") IActions.ActiveActions.OpenBox.IconNum = 2;

			if(Pchar.location == "wr_farm_corridor") IActions.ActiveActions.OpenBox.IconNum = 2;

			if(Pchar.location == "wr_farm_servant")
			{
				if(Pchar.boxname == "box2")
				{
					IActions.ActiveActions.OpenBox.IconNum	= 62;
				}
				else IActions.ActiveActions.OpenBox.IconNum = 2;
			}

			if(Pchar.location == "wr_farm_alchemy")
			{
				if(Pchar.boxname == "box3")
				{
					IActions.ActiveActions.OpenBox.IconNum    = 59;
				}
				else
				{
					if(Pchar.boxname != "box1") IActions.ActiveActions.OpenBox.IconNum    = 2;
				}
			}

			if(Pchar.location == "wr_ships" || Pchar.location == "wr_corvette")
			{
				if(Pchar.boxname == "box8")
				{
					if(CheckAttribute(Pchar,"quest.anchor_mechanism") && Pchar.quest.anchor_mechanism == "complete")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 25;
					}
					else
					{
						if(CheckAttribute(Pchar,"quest.anchor") && Pchar.quest.anchor == "up")
						{
							IActions.ActiveActions.OpenBox.IconNum	= 25;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 2;
					}
				}
				else
				{
					if(Pchar.boxname == "box9")
					{
						if(CheckAttribute(Pchar,"quest.anchor_mechanism") && Pchar.quest.anchor_mechanism == "complete")
						{
							IActions.ActiveActions.OpenBox.IconNum	= 25;
						}
						else IActions.ActiveActions.OpenBox.IconNum    = 2;
					}
				}
				else
				{
					if(Pchar.boxname == "box18" || Pchar.boxname == "box19" || Pchar.boxname == "box20"
					|| Pchar.boxname == "box15" || Pchar.boxname == "box16" || Pchar.boxname == "box17")
						{IActions.ActiveActions.OpenBox.IconNum	= 63;}
				}
				else
				{
					if(Pchar.boxname == "box21" || Pchar.boxname == "box22")
						{IActions.ActiveActions.OpenBox.IconNum	= 61;}
				}
				else
				{
					if(Pchar.boxname == "box5" || Pchar.boxname == "box6" || Pchar.boxname == "box7")
						{IActions.ActiveActions.OpenBox.IconNum	= 58;}
				}
				else
				{
					if(Pchar.boxname == "box3") IActions.ActiveActions.OpenBox.IconNum	= 57;
				}
				else
				{
					if(Pchar.boxname == "box23")
					{
						if(CheckAttribute(Pchar,"quest.anchor") && Pchar.quest.anchor == "up")
						{
							IActions.ActiveActions.OpenBox.IconNum = 2;
						}
						else IActions.ActiveActions.OpenBox.IconNum	= 3;
					}
				}
				else
				{
					if(Pchar.boxname == "box24") IActions.ActiveActions.OpenBox.IconNum	= 3;
				}
				else IActions.ActiveActions.OpenBox.IconNum = 2;
			}

			if(Pchar.location == "wr_gall_hold_first")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}
				if(Pchar.boxname == "box4" || Pchar.boxname == "box5" || Pchar.boxname == "box6")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}

				if(Pchar.boxname == "box7") IActions.ActiveActions.OpenBox.IconNum	= 0;
			}

			if(Pchar.location == "wr_gall_hold_second")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 63;
				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum 	= 2;
			}

			if(Pchar.location == "wr_gall_deck2_prow") IActions.ActiveActions.OpenBox.IconNum = 2;

			if(Pchar.location == "wr_gall_deck2_stern")
			{
				if(Pchar.boxname == "box5" || Pchar.boxname == "box6" || Pchar.boxname == "box11")
				{
					IActions.ActiveActions.OpenBox.IconNum	= 2;
				}
				else
				{
					if(Pchar.boxname == "box12") IActions.ActiveActions.OpenBox.IconNum	= 63;
				}
				else IActions.ActiveActions.OpenBox.IconNum	= 3;
			}

			if(Pchar.location == "wr_gall_cap_inner")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum	= 3;
			}

			if(Pchar.location == "wr_gall_captain")
			{
				if(Pchar.boxname == "box3")
				{
					if(CheckAttribute(Pchar,"quest.gall_captain") && Pchar.quest.gall_captain == "open")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 3;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 2;
				}
			}

			if(Pchar.location == "wr_corv_smallcabin_L")
			{
				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum	= 63;
				if(Pchar.boxname == "box3") IActions.ActiveActions.OpenBox.IconNum	= 2;
			}

			if(Pchar.location == "wr_corv_smallcabin_R")
			{
				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum	= 63;
			}

			if(Pchar.location == "wr_corv_deck1")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum    = 2;
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3" || Pchar.boxname == "box4")
					IActions.ActiveActions.OpenBox.IconNum    = 63;
			}

			if(Pchar.location == "wr_corv_crew")
			{
				if(Pchar.boxname == "box3") IActions.ActiveActions.OpenBox.IconNum    = 2;

				if(Pchar.boxname == "box4")
				{
					if(CheckAttribute(Pchar,"quest.crew_to_ships") && Pchar.quest.crew_to_ships == "closed")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 0;
					}
					else IActions.ActiveActions.OpenBox.IconNum    = 63;
				}
			}

			if(Pchar.location == "wr_corv_capmd")
			{
				if(Pchar.boxname == "box3") IActions.ActiveActions.OpenBox.IconNum    = 2;
				if(Pchar.boxname == "box4") IActions.ActiveActions.OpenBox.IconNum    = 63;
			}

			if(Pchar.location == "wr_corv_capsm")
			{
				if(Pchar.boxname == "box2" || Pchar.boxname == "box3") IActions.ActiveActions.OpenBox.IconNum    = 2;
				if(Pchar.boxname == "box4") IActions.ActiveActions.OpenBox.IconNum    = 63;
			}

			if(Pchar.location == "wr_wine_cellar") IActions.ActiveActions.OpenBox.IconNum    = 2;

			if(Pchar.location == "church_wine_cellar")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box3"
				|| Pchar.boxname == "box4" || Pchar.boxname == "box5" || Pchar.boxname == "box6"
				|| Pchar.boxname == "box7" || Pchar.boxname == "box13")
					{IActions.ActiveActions.OpenBox.IconNum	= 2;}

				if(Pchar.boxname == "box17" || Pchar.boxname == "box19") IActions.ActiveActions.OpenBox.IconNum    = 1;

				if(Pchar.boxname == "box14" || Pchar.boxname == "box15" || Pchar.boxname == "box16"
				|| Pchar.boxname == "box18")
				{
					if(Locations[FindLocation(Pchar.location)].models.always.locators == "cwc_dry_final")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum    = 0;
				}
			}

			if(Pchar.location == "church_choir")
			{
				if(Pchar.boxname == "box6" || Pchar.boxname == "box14" || Pchar.boxname == "box15")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}

				if(Pchar.boxname == "box7" || Pchar.boxname == "box11" || Pchar.boxname == "box12")
					{IActions.ActiveActions.OpenBox.IconNum	= 62;}



				if(Pchar.boxname == "box8" || Pchar.boxname == "box9" || Pchar.boxname == "box13"
				|| Pchar.boxname == "box16")
					{IActions.ActiveActions.OpenBox.IconNum	= 56;}

				if(Pchar.boxname == "box18" || Pchar.boxname == "box19")
					{IActions.ActiveActions.OpenBox.IconNum	= 1;}

				if(Pchar.boxname == "box2")
				{
					switch(Pchar.quest.choir_ladder)
					{
						case "not_found":
							//Logit(TranslateString("","The lock is too rusty - I can't move the key."));
							IActions.ActiveActions.OpenBox.IconNum	= 29;
						break;

						case "found":
							if(IsEquipCharacterByItem(Pchar, "bladeladder"))
							{
								if(LAi_IsFightMode(Pchar))
								{
									//this is your 2:nd 'open box'
									//LAi_QuestDelay("place_ladder_choir_box2", 1.0);
									IActions.ActiveActions.OpenBox.IconNum    = 2;
								}
								else
								{
									//ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck2");
									//LAi_SetFightMode(chr, true);
									IActions.ActiveActions.OpenBox.IconNum    = 2;
								}
							}
							else
							{
								//Logit(TranslateString("","The lock is too rusty - I can't move the key."));
								IActions.ActiveActions.OpenBox.IconNum	= 29;
							}
						break;

						case "placed":
							//later when ladder is placed
							//ChangeCharacterAddressGroup(chr, "church_choir", "goto", "ladder1");
							IActions.ActiveActions.OpenBox.IconNum    = 63;
						break;

						case "oilbottle":
							if(IsEquipCharacterByItem(Pchar, "bladeoilbottle"))
							{
								if(LAi_IsFightMode(Pchar))
								{
									//this is your 2:nd 'open box'
									//PlaySound("PEOPLE\oil_unlock.wav");
									IActions.ActiveActions.OpenBox.IconNum    = 2;

								}
								else
								{
									//ChangeCharacterAddressGroup(Pchar, "church_choir", "goto", "stuck2");
									//LAi_SetFightMode(Pchar, true);
									IActions.ActiveActions.OpenBox.IconNum    = 2;
								}
							}
							else
							{
								//ChangeCharacterAddressGroup(Pchar, "church_choir", "goto", "ladder1");
								IActions.ActiveActions.OpenBox.IconNum    = 63;
							}
						break;

						case "blocking":
							if(LAi_IsFightMode(Pchar))
							{
								//this is your 2:nd 'open box'
								//GiveItem2Character(chr, "bladeladder");
								//EquipCharacterbyItem(chr, "bladeladder");
								//LAi_QuestDelay("remove_ladder_choir_box2", 0.5);
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
							else
							{
								//ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck2");
								//LAi_SetFightMode(chr, true);
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
						break;

						case "open_chest":
							//LaunchItemsBox(&ar);
							IActions.ActiveActions.OpenBox.IconNum	= 29;
						break;
					}
				}

				if(Pchar.boxname == "box3")
				{
					if(CheckCharacterItem(Pchar,"PiratesDagger")) IActions.ActiveActions.OpenBox.IconNum = 2;
				}

				if(Pchar.boxname == "box4")
				{
					if(CheckCharacterItem(Pchar,"bladelockpick")) IActions.ActiveActions.OpenBox.IconNum = 2;
				}

				if(Pchar.boxname == "box5")
				{
					if(CheckCharacterItem(Pchar,"bladehandle")) IActions.ActiveActions.OpenBox.IconNum = 2;
				}

				if(Pchar.boxname == "box17")
				{
					if(CheckCharacterItem(Pchar, "bladekeygrand"))
					{
						IActions.ActiveActions.OpenBox.IconNum    = 2;
					}
					else
					{
						if(CheckAttribute(Pchar, "quest.choir_clock") && Pchar.quest.choir_clock == "clock_started")
						{
							IActions.ActiveActions.OpenBox.IconNum    = 55;
						}
						else
						{
							if(CheckAttribute(Pchar, "quest.choir_clock") && Pchar.quest.choir_clock == "key_placed")
							{
								IActions.ActiveActions.OpenBox.IconNum    = 2;
							}
						}
						else
						{
							IActions.ActiveActions.OpenBox.IconNum    = 55;
						}
					}
				}
			}

			if(Pchar.location == "wr_sacristy")
			{
				if(Pchar.boxname == "box1") IActions.ActiveActions.OpenBox.IconNum    = 2;

				if(Pchar.boxname == "box2")
				{
					if(CheckAttribute(Pchar, "quest.votiv_lever") && Pchar.quest.votiv_lever == "F")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 1;
					}
					else IActions.ActiveActions.OpenBox.IconNum    = 0;
				}
			}

			if(Pchar.location == "wr_cave_shore")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2" || Pchar.boxname == "box4")
					IActions.ActiveActions.OpenBox.IconNum    = 2;

				if(Pchar.boxname == "box5" || Pchar.boxname == "box7"
				|| Pchar.boxname == "box8" || Pchar.boxname == "box9" || Pchar.boxname == "box6")
					{IActions.ActiveActions.OpenBox.IconNum	= 63;}

				if(Pchar.boxname == "box3")
				{
					if(CheckAttribute(Pchar, "quest.cave_shore_red_chest") && Pchar.quest.cave_shore_red_chest == "free")
					{
						IActions.ActiveActions.OpenBox.IconNum	= 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum	= 63;
				}

				if(Pchar.boxname == "box10") IActions.ActiveActions.OpenBox.IconNum    = 3;
			}

			if(Pchar.location == "wr_wood_tower2")
			{
				if(Pchar.boxname == "box1" || Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum    = 58;
			}

			if(Pchar.location == "wr_wood_tower3")
			{
				if(Pchar.boxname == "box1")
				{
					if(CheckAttribute(Pchar,"quest.wt3_box1") && Pchar.quest.wt3_box1 == "large")
					{
						IActions.ActiveActions.OpenBox.IconNum    = 2;
					}
					else IActions.ActiveActions.OpenBox.IconNum    = 3;
				}

				if(Pchar.boxname == "box2") IActions.ActiveActions.OpenBox.IconNum    = 63;
			}
	    }
	}
//<-- JRH
}

void DrawCharacterHP(float myHP,float enemyHP)
{
	if(bYesBoardStatus==false)
	{
		CreateEntity(&IBoardingStatus,"IBoardingStatus");
		IBoardingStatus.myLeft = sti(showWindow.left)+16;
		IBoardingStatus.myTop = sti(showWindow.bottom)-140;
		IBoardingStatus.enemyLeft = sti(showWindow.left)+16;
		IBoardingStatus.enemyTop = sti(showWindow.bottom)-128;
		IBoardingStatus.height = RecalculateVIcon(8);
		IBoardingStatus.width = RecalculateHIcon(120);
		IBoardingStatus.myColor = argb(255,0,0,128);
		IBoardingStatus.enemyColor = argb(255,128,0,0);
		SendMessage(&IBoardingStatus,"l",LOG_INIT_CHARCTER_HP);
		bYesBoardStatus = true;
	}
	if(myHP==0)
	{
		bYesBoardStatus=false;
		DeleteClass(&IBoardingStatus);
		DeleteAttribute(&IBoardingStatus,"");
	}
	if(enemyHP==0)
	{
		bYesBoardStatus=false;
		DeleteClass(&IBoardingStatus);
		DeleteAttribute(&IBoardingStatus,"");
	}
	SendMessage(&IBoardingStatus,"lff",LOG_SET_CHARCTER_HP,myHP,enemyHP);
}

void BI_FastCommand()
{
	int tmpi;
	string FComName = GetEventData();

	if( LAi_IsDead(GetMainCharacter()) ) return;

	if(bSeaActive && !bAbordageStarted)
	{
		switch(FComName)
		{
			case "Moor":
				bDisableAllCommands = true; // KK
				PostEvent("BI_SetPossibleCommands", 0.0, "l", -1); // KK
				Sea_LandLoad();
			break;
			case "Board":		Sea_AbordageLoad(SHIP_ABORDAGE,true);	break;
			case "LandTroops":	Sea_AbordageLoad(FORT_ABORDAGE,true);	break;
			case "Map":			Sea_MapLoad();	break;
// KK -->
			case "Transfer":
				if(bi_nReloadTarget!=-1)
				{
					LaunchTransferMain(GetMainCharacter(),GetCharacter(bi_nReloadTarget),"");
				}
			break;
			case "EnterFort":
				bDisableAllCommands = true;
				PostEvent("BI_SetPossibleCommands", 0.0, "l", -1);
				Sea_LandLoad();
			break;
// <-- KK
		}
	}
	else
	{
		if(CheckAttribute(GetMainCharacter(),"Quests.quest_act"))
		{
			Event("evntQuestComplete","s",Characters[GetMainCharacterIndex()].Quests.quest_act);
			return;
		}
		switch(FComName)
		{
			case "OpenBox":	OpenBoxProcedure();	break;
			case "OpenWeaponsLocker": OpenBoxProcedure();	break; // KK
			case "OpenBarrel": OpenBoxProcedure();	break; // KK
			case "Pick": Item_OnPickItem(); break;
			case "Action": Item_OnUseItem(); break;
			case "Talk":
				tmpi = SendMessage(GetMainCharacter(),"ls",MSG_CHARACTER_EX_MSG,"FindDialogCharacter");
				if(tmpi>=0) Event("dlgReady","l",tmpi);
			break;
			case "Reload": Event("Control Activation","s","ChrAction"); break;
			//case "Closed": break;
			//case "Look": break;
			case "ToSea": Event("Control Activation","s","ChrAction"); break;
			//MAXIMUS -->
			case "TalkWith"://added for showing additional icons
				tmpi = SendMessage(GetMainCharacter(),"ls",MSG_CHARACTER_EX_MSG,"FindDialogCharacter");
				if(tmpi>=0) Event("dlgReady","l",tmpi);
			break;
			case "ToBrothel": Event("Control Activation","s","ChrAction"); break;
			case "ToTavern": Event("Control Activation","s","ChrAction"); break;
			case "ToResidence": Event("Control Activation","s","ChrAction"); break;
			case "ToShipyard": Event("Control Activation","s","ChrAction"); break;
			case "ToStore": Event("Control Activation","s","ChrAction"); break;
			case "ToUsurer": Event("Control Activation","s","ChrAction"); break;
			case "ToChurch": Event("Control Activation","s","ChrAction"); break;
			case "ToAcademy": Event("Control Activation","s","ChrAction"); break;
			case "ToArsenal": Event("Control Activation","s","ChrAction"); break;
			case "ToFightDeck": Event("Control Activation","s","ChrAction"); break;
			//MAXIMUS <--
// KK -->
			case "ToTailor": Event("Control Activation", "s", "ChrAction"); break;
			case "ToBlacksmith": Event("Control Activation", "s", "ChrAction"); break;
			case "ToPrison": Event("Control Activation", "s", "ChrAction"); break;
			case "ToFort": Event("Control Activation", "s", "ChrAction"); break;
			case "ToPort": Event("Control Activation", "s", "ChrAction"); break;
			case "ToShore": Event("Control Activation", "s", "ChrAction"); break;//MAXIMUS
			case "ToBoat": Event("Control Activation", "s", "ChrAction"); break;
			case "ToShipDeck": Event("Control Activation", "s", "ChrAction"); break;
			case "ToCabin": Event("Control Activation", "s", "ChrAction"); break;
			case "ToCannonsDeck": Event("Control Activation", "s", "ChrAction"); break;
			case "ToCargoHold": Event("Control Activation", "s", "ChrAction"); break;
			case "ToSeaDogs": Event("Control Activation", "s", "ChrAction"); break;
			case "ToTown": Event("Control Activation", "s", "ChrAction"); break;
			case "ToJungle": Event("Control Activation", "s", "ChrAction"); break;
			case "ToMap": Event("Control Activation", "s", "ChrAction"); break;
			case "Corpse": OpenBoxProcedure(); break;
			case "Idol": Item_OnUseItem(); break;
// <-- KK
		}
	}
}

void ClearAllLogStrings()
{
	SendMessage(&ILog,"l",LI_CLEAR_STRINGS);
}

// KK -->
void ClearEternalString()
{
	SendMessage(&ILog,"lls",LOG_ADD_STRING, true, "");
}
// <-- KK

void BI_GetMsgIconRoot()
{
	aref arTmp;
	aref pARef[4];
	int i,idx,cn;
	idx = 0;

	if(bSeaActive && !bAbordageStarted)
	{
		for(i=0; i<4; i++)
		{
			cn = GetCompanionIndex(GetMainCharacter(),i);
			if(cn<0) {continue;}
			Characters[cn].MessageIcons = true;
			makearef(arTmp,Characters[cn].MessageIcons);
			pARef[idx] = arTmp;
			idx++;
		}
		SendMessage(&BattleInterface,"le", BI_MSG_SET_MSG_ICONS, &pARef);
	}
	else
	{
		for(i=0; i<4; i++)
		{
			cn = GetOfficersIndex(GetMainCharacter(),i);
			if(cn<0) {continue;}
			Characters[cn].MessageIcons = true;
			makearef(arTmp,Characters[cn].MessageIcons);
			pARef[idx] = arTmp;
			idx++;
		}
		SendMessage(&objLandInterface,"le", MSG_BATTLE_LAND_SET_MSGICONS, &pARef);
	}
}

void LoadLIStates()
{
	if(GetMainCharacterIndex()<0) return;
	int i,cn;
	ref mc = GetMainCharacter();
	ref chref;

	DeleteAttribute(mc,"MessageIcons");
	for(i=1; i<4; i++)
	{
		cn = GetOfficersIndex(mc,i);
		if(cn>=0)
		{
			chref = GetCharacter(cn);
			DeleteAttribute(chref,"MessageIcons");
		}
		cn = GetCompanionIndex(mc,i);
		if(cn>=0)
		{
			chref = GetCharacter(cn);
			DeleteAttribute(chref,"MessageIcons");
		}
	}
}

// KK -->
void InitDateTimeDisplay()
{
	CreateEntity(&IDateTimeDisplay, "IDateTime_Show");
	DeleteAttribute(&IDateTimeDisplay, "");
	LayerAddObject("execute", &IDateTimeDisplay, -257);
	LayerAddObject("realize", &IDateTimeDisplay, -257);
	LayerAddObject(SEA_EXECUTE, &IDateTimeDisplay, -257);
	LayerAddObject(SEA_REALIZE, &IDateTimeDisplay, -257);
}

void DeleteDateTimeDisplay()
{
	if (isEntity(&IDateTimeDisplay)) {
		ref PChar = GetMainCharacter();
		// LDH keep the hour bells from updating again when changing islands - 11Jan09
		if (CheckAttribute(PChar, "DisplayTime")) DeleteAttribute(PChar, "DisplayTime");	// LDH 15Jan09

		bHourBellPlayed=false;		// LDH added 20Dec08
		bIslandChecked = false;		// LDH added 07Jan09
		bAiUpdated=false;		// Screwface
		// LDH - Moved to reload.c - 12Feb09
//		PChar.directsail.count = 0.0;	// LDH reset encounter frequency count every time we leave the 3d sea environment - 14Jan09

		DeleteClass(&IDateTimeDisplay);
	}
}

void CreateDateTimeDisplay()
{
	ref rtmp;
	makeref(rtmp, IDateTimeDisplay);
	DeleteAttribute(rtmp, "");
	CopyAttributes(rtmp, &ILog);
	IDateTimeDisplay.Log.width = RecalculateHIcon(makeint(stf(showWindow.width) * 0.5));
	IDateTimeDisplay.Log.height = RecalculateVIcon(10);
	IDateTimeDisplay.Log.left = sti(showWindow.left) + makeint(stf(showWindow.width) * 0.475);
	IDateTimeDisplay.Log.up = sti(showWindow.top) + RecalculateVIcon(10);
	IDateTimeDisplay.Log.font = "interface_normal";
	IDateTimeDisplay.Log.color = argb(0,255,255,255);
	IDateTimeDisplay.Log.offsetString = 24;
	IDateTimeDisplay.Log.speed = 1.0;
	IDateTimeDisplay.Log.color_speed = 0.0;
	SendMessage(&IDateTimeDisplay, "lll", LOG_AND_ACTIONS_INIT, false, true);

	int iyear = GetDataYear();
	int imonth = GetDataMonth();
	int iday = GetDataDay();
	sDateTimeDisplay = XI_ConvertString(GetDayName(GetWeekday(iday, imonth, iyear))) + ", " + GetHumanDate(iyear, imonth, iday);

	ref chMain = GetMainCharacter();
	bool btmp = (DISPLAY_TIME == 2);
	if (DISPLAY_TIME == 1) btmp = (CheckCharacterEquipByGroup(chMain, CLOCK_ITEM_TYPE) != "");
	if (btmp) {
		// LDH keep the hour bells from updating again when changing islands - 11Jan09
		chMain.HasClock = true;		// LDH added 15Jan09
	} else {
		chMain.HasClock = false;
		SendMessage(&IDateTimeDisplay, "lls", LOG_ADD_STRING, true, sDateTimeDisplay);
	}

	if (!CheckAttribute(chMain, "BaseCurrentTime")) chMain.BaseCurrentTime = 0.0;
	chMain.DisplayTime = true;	// LDH - causes datetime to display, added 15jan09
	bHourBellPlayed  = false;	// LDH added 20Dec08
	bIslandChecked   = false;	// LDH added 07Jan09
	bAiUpdated	= false;	// Screwface
	PostEvent("evntUpdateTime", 250.0);
}

// LDH accumulate sailing experience - 21Dec08
void AccumSailTime()
{
	ref mchr = GetMainCharacter();

//	if ( ! IsPerkIntoList("TimeSpeed"))		// not in compressed time
//	{
		if (!CheckAttribute(mchr, "SailingMinutes")) mchr.SailingMinutes = 0;
		mchr.SailingMinutes = sti(mchr.SailingMinutes) + 1;		// Note: do we want to add more if in battle?
//	}
}

// LDH time display 17Sep06
void procUpdateTime()
{
	ref mchr = GetMainCharacter();
	bool bCheckForBells = false;
	bool bCheckForIslandChange = false;		// LDH 07Jan09
	bool bCheckForAiupdate = false;			// screwface
	string timeString;
	int theHour;
	int theMinute;

	if (CheckAttribute(mchr, "DisplayTime"))		// LDH changed from BaseCurrentTime - 15Jan09
	{
		float fGetTime = GetTime();					// GetTime() updates every 5 game minutes
		int iSeaTime = GetSeaTime();				// GetSeaTime() returns approx number of seconds since sea started
		if (stf(mchr.BaseCurrentTime) != fGetTime)
		{
			mchr.CurrentTime = fGetTime;
			mchr.BaseCurrentTime = fGetTime;
			mchr.TimeSeconds = iSeaTime;
			if (bSeaActive)
			{
				AccumSailTime();	// LDH accumulate sailing experience - 21Dec08
				bCheckForBells = true;
				bCheckForIslandChange = true;
				bCheckForAiupdate = true;
			}
		}
		if (iSeaTime >= sti(mchr.TimeSeconds)+60/TIMESCALAR_SEA)	// 12 seconds, this is approximate, but works
		{
			mchr.TimeSeconds = iSeaTime;
			float CurrentTime = stf(mchr.CurrentTime);
			CurrentTime += (1.0/60.0);								// add one minute to current time
			if (CurrentTime >= 24.0) CurrentTime -= 24.0;			// LDH 16Oct06 - 24:01 should be 00:01 for example
			mchr.CurrentTime = CurrentTime;
			AccumSailTime();	// LDH accumulate sailing experience - 21Dec08
			if (bSeaActive)
			{
				bCheckForBells = true;
				bCheckForIslandChange = true;
				bCheckForAiupdate = true;
			}
		}

		if (bCheckForBells)
		{
			//HKE -->
			// LDH simplify code - 20Dec08
			timeString = GetStringTime(stf(mchr.CurrentTime));
			theMinute = sti(strRight(timeString,2));
			if (theMinute == 0 || theMinute == 30)
			{
				if ( ! bHourBellPlayed )
				{
//TraceAndLog("TIME at hour bell: " + makeint(GetHour()) + ":" + stringRet(GetMinute()<10,"0","") + makeint(GetMinute()) );	// LDH 04Jan09
					theHour = sti(timeString);
					int numBells = (theHour % 4) * 2;
					if (theMinute == 30) numBells += 1;
					if (numBells == 0) numBells = 8;
					switch (numBells)
					{
						case 1:	PlaySound("AMBIENT\SEA\bell1_0030_0430_0830.wav"); break;
						case 2:	PlaySound("AMBIENT\SEA\bell2_0100_0500_0900.wav"); break;
						case 3:	PlaySound("AMBIENT\SEA\bell3_0130_0530_0930.wav"); break;
						case 4:	PlaySound("AMBIENT\SEA\bell4_0200_0600_1000.wav"); break;
						case 5:	PlaySound("AMBIENT\SEA\bell5_0230_0630_1030.wav"); break;
						case 6:	PlaySound("AMBIENT\SEA\bell6_0300_0700_1100.wav"); break;
						case 7:	PlaySound("AMBIENT\SEA\bell7_0330_0730_1130.wav"); break;
						case 8:	PlaySound("AMBIENT\SEA\bell8_0400_0800_1200.wav"); break;
					}
					bHourBellPlayed = true;

					// LDH get experience for manual sailing - 21Dec08
					int Exp = 0;
					if (AUTO_SKILL_SYSTEM)
					{
						if(OPEN_SEA_MOD){
							if (CheckAttribute(mchr, "SailingMinutes")) Exp = sti(mchr.SailingMinutes) * 0.8; // was 35 stljeffbb Jan 15 2012
						}else{
							if (CheckAttribute(mchr, "SailingMinutes")) Exp = sti(mchr.SailingMinutes) * 35;
						}
						AddPartyExpChar(mchr, "Sailing", Exp);
					}
					else
					{
						//BB was * 35, now * 15 (Aim of this section of tweaks: reduction in XP given out during Direct Sailing) - 15July2011
						if(OPEN_SEA_MOD){
							if (CheckAttribute(mchr, "SailingMinutes")) Exp = sti(mchr.SailingMinutes) * 0.8; // was 35 stljeffbb Jan 15 2012
							AddPartyExp(mchr, Exp * 0.2); //orig 0.5 so BB added * 0.5
						}else{
							if (CheckAttribute(mchr, "SailingMinutes")) Exp = sti(mchr.SailingMinutes) * 15;
							AddPartyExp(mchr, Exp * 0.5); //BB added * 0.5
						}
					}
					mchr.SailingMinutes = 0;

					if (ACCURATE_NAVIGATION && theMinute == 0)	// LDH added 30Jan09
					{
						if (!CheckAttribute(mchr, "directsail1.daysout")) mchr.directsail1.daysout = 0;
						mchr.directsail1.daysout = sti(mchr.directsail1.daysout) + 1;
					}
					// LDH added for direct sailing - 02Jan09
					if (ACCURATE_NAVIGATION && theMinute == 0 && theHour != 0)
					{
						// Do daily update but not if we're in battle
						if ( !bDisableMapEnter )	// LDH added 27Jan09
						{
							Trace("== Directsail added a day to sailing time");
							if(!OPEN_SEA_MOD) // turned off for open sea mod stljeffbb Jan 15 2012
								WaitDate("", 0, 0, 1, 0, 0); // "", years, months, days, hours, minutes
						}
					}
				}
			}
			else
			{
				bHourBellPlayed = false;
			}
			//<-- HKE
		}

		// LDH check for island changes more often - 07Jan09
		if ( ACCURATE_NAVIGATION && bCheckForIslandChange )
		{
			timeString = GetStringTime(stf(mchr.CurrentTime));
			theMinute = sti(strRight(timeString,2));
			if (theMinute != 0 && theMinute+1 != 60 && ((theMinute+1) % DirectsailCheckFrequency) == 0)	// check every DirectsailCheckFrequency minutes
			{
				if ( ! bIslandChecked )
				{
					Trace("== Directsail called at " + timestring);
					mchr.directsail.count = stf(mchr.directsail.count) + DirectsailCheckFrequency/60.0; // update encounter frequency count
//TraceAndLog("Directsail encounter check = " + stf(mchr.directsail.count));
					DirectSailCheck();
					bIslandChecked = true;
				}
			}
			else
			{
				bIslandChecked = false;
			}
		}

		// SCREWFACE : UPDATE AI
		if(bCheckForAiupdate)
		{
			timeString = GetStringTime(stf(mchr.CurrentTime));
			theMinute = sti(strRight(timeString,2));
			int frequency = UPDATE_AI_FREQUENCY;
			if (CheckAttribute(mchr, "obsenemy")) {frequency = 1;DeleteAttribute(mchr, "obsenemy");}
			if(((theMinute+1) % frequency) == 0)
			{
				if (!bAiUpdated)
				{
					int i;
					//crgchar = CharacterFromID(crg); // NK 04-09-09
					string groupe; // = GetGroupIDFromCharacter(crgchar);
					ref rGroup;

					for (i=0; i<MAX_SHIP_GROUPS; i++)
					{
						rGroup = Group_GetGroupByIndex(i);
						if(CheckAttribute(rGroup,"AlreadyLoaded"))
						{
							//Logit(" " + rgroup.id + " ");

							if (!CheckAttribute(rGroup, "id")) { continue; }
							if (!CheckAttribute(rGroup, "location")) { continue; }
							if (rGroup.location != mchr.location) { continue; }
							//crgchar = Group_GetGroupCommanderR(rGroup);
							groupe = rGroup.id;

							Improve_SeaAi(groupe);
						}
						else
						{
							if(CheckAttribute(rGroup, "id") && HasSubStr(rGroup.id, "Directenc"))
							{
								Improve_SeaAi(rGroup.id);
							}
						}
					}
					bAiUpdated = true;

					if(CheckAttribute(mchr,"Delayrefresh") && !CheckAttribute(mchr,"Waitdelay"))
					{
						// Refresh ships who needs to be updated
						Refresh_delayed_Flags();
						waitdelay();
						DeleteAttribute(mchr,"Delayrefresh");
					}
				}
				else
				{
					bAiUpdated = false;
				}
			}

			// Screwface : lagoon color mod close to seashore reload locator
			if(mchr.location !="")
			{
				string island = mchr.location;
				int li = Findisland(island);
				//logit("island : " + island);
				if(li >= 0)
				{
					aref aCurWeather = GetCurrentWeather();
					float psX = MakeFloat(mchr.Ship.Pos.x);
					float psZ = MakeFloat(mchr.Ship.Pos.z);
					float isR = 450.0;
					//logit("ship pos x : " + psx);
					//logit("ship pos z : " + psz);
					aref rl;
					makearef(rl, Islands[li].reload);
					int num = GetAttributesNum(rl);
					for(int j = 0; j < num; j++)
					{
						string tempattrname = GetAttributeName(GetAttributeN(rl,j));
						//sLandfallName = rl.(tempattrname).label;
						if (CheckAttribute(rl, tempattrname+".x"))
						{
							float ix = stf(rl.(tempattrname).x);
							float iz = stf(rl.(tempattrname).z);
							if(aCurWeather.id == "Blue Sky")
							{
								if(wRain < 75)
								{
									if(GetDistance2D(psX, psZ, ix, iz) <= isR && Locations[FindLocation(rl.(tempattrname).go)].type =="seashore")
									{
										//logit("loc pos x : " + ix);
										//logit("loc pos z : " + iz);
										if(!Checkattribute(rl, tempattrname+".inlagoon"))
										{
											//Logit("i'm in a lagoon !");
											//Sea.GF3.WaterColor = argb(0,45,129,153);
											Refreshseacolor_in();
											rl.(tempattrname).inlagoon = 1;
											break;
										}
									}
									else
									{
										if(CheckAttribute(rl, tempattrname+".inlagoon"))
										{
											//Logit("i'm not in a lagoon !");
											aCurWeather.Sea.inlagoon = 0;
											Refreshseacolor_out();
											//Sea.GF3.WaterColor = argb(0,30,55,100);
											DeleteAttribute(rl, tempattrname+".inlagoon");
										}
									}
								}
								else
								{
									Sea.GF3.WaterColor = aCurWeather.Sea.Water.Color;
									Sea.GF3.SkyColor = aCurWeather.Sea.Sky.Color;
									Sea.WaterAttenuation = aCurWeather.Sea.WaterAttenuation;
								}
							}
						}
					}
				}
			} // Screwface : Lagoon color mod end
		}
		// SCREWFACE : END


		int iyear = GetDataYear();
		int imonth = GetDataMonth();
		int iday = GetDataDay();
		sDateTimeDisplay = XI_ConvertString(GetDayName(GetWeekday(iday, imonth, iyear))) + ", " + GetHumanDate(iyear, imonth, iday);
		if (sti(mchr.HasClock)) sDateTimeDisplay += " " + GetStringTime(stf(mchr.CurrentTime));
		// PB: Only show this if Various Logs are enabled -->
		if(LogsToggle) SendMessage(&IDateTimeDisplay, "lls", LOG_ADD_STRING, true, sDateTimeDisplay);
		else SendMessage(&IDateTimeDisplay, "lls", LOG_ADD_STRING, true, "");
		// PB: Only show this if Various Logs are enabled <--

		PostEvent("evntUpdateTime", 250.0);	// when DisplayTime attribute is deleted, this will stop calling itself
	}
}
// <-- KK
