/*// ===============================================| MAXIMUS |===============================================
Finally I made an interface for change all BUILD-settings in options-interface. All #defines were changed to variables
for making them changeable

Description for each option must be added into RESOURCE\INI\TEXT\*needed language*\SettingsDescribe.txt
*name_of_the_option*{translated text} (for example: changing_relations{Changing nations relations})
setting*name_of_the_option*1 (for example: settingchanging_relations1)
{
Describe for lowest value
}
setting*name_of_the_option*2
{
Describe for higher value
}
setting*name_of_the_option*3
{
#Describe for whole option
}
*/// ===============================================| MAXIMUS |===============================================

// ======================================
// STARTING OPTIONS FOR A NEW GAME:
// ======================================

bool CHANGING_RELATIONS	= false;
	// 0: Relations between different nations are constant (original stock game)
	// 1: Relations between different nations can change over time

bool AUTO_SKILL_SYSTEM = true;
	// 1: Skills will be distributed automatically, depending on player-actions
	// 0: Player must distribute character's skills manually (Stock PotC)

// ======================================
// GENERAL MODS:
// ======================================

int DEATHRATE = 40;
	// Chance of dying(= game over) after shipwrecks and lost fights
	// Choose a value between 1(certain survival) and 130(certain death)
	// After survival you will be down and out, so it is a new challenge and no cheat!

bool ENABLE_WEAPONSMOD = true;
	// 1: Weapons have different quality grades: from "Badly worn" to "Excellent"
	// 0: Off, stock PotC

int IRON_MAN_MODE = 0;
	// Makes the info given by spyglasses unaccurate and depending of distance
	//	0: Stock PotC: Deactivate mod
	//	1: Worldmap sailing, Sail To, minimap and spyglass additional information disabled


// ======================================
// WORLDMAP & SHIP ENCOUNTERS:
// ======================================

bool START_DIFF_SHIPCAP	= 0;
	// 1: Takes player's level and ship class into account when generating ship encounters
	// 0: Encounters are completely random

int WDMAP_SHIP_SHOW_MODE = 0;
	// Determines what ships are shown on the worldmap and how
	// 0: Stock PotC, all ships shown with national sail colours
	// 1: All ships visible, but nationality for all but pirate hidden
	// 2: No nations shown
	// 3: No ships at all shown

int NATIONAL_PAINT_SCHEMES = 1;
	// Determines if the paint schemes of ships are dependent on their nationality
	// 1: Yes
	// 0: No

int SAILHO_INFOLEVEL = 2;
	// Amount of info in the "sailho" screenmessage on the map
	// 0: Reports only "some ship"
	// 1: Adds ship group type
	// 2: Adds nationality


// ======================================
// SAILING & SHIP BATTLES:
// ======================================

float SURR_GLOBAL_SCL = 0.01;
	// Ships will surrender if damage or crew morale become critical
	// 0.0 : Stock PotC, no surrenders
	// 0.01 - 0.5 : The higher that value the faster ships surrender

bool VISIT_DECK = true;
	// 0: Stock PotC: When anchoring, you go directly to shore; also you go directly to sea when leaving port or bay.
	// 1: When anchoring, you go to your ship's deck. From there you can go to shore in the same way as in the tutorial.
	//    When leaving land you'll also go to your ship's deck, unless you select 'Sea' command.

bool SHIPCLASS_DEPENDS_ON_SKILLS = true;
	// 0: Stock PotC: Character can command any class of ship
	// 1: When player takes command of ship of too high class Leadership and Sailing skills drops


// ======================================
// CANNONS
// ======================================

bool USE_REAL_CANNONS = true;
	// 0: Stock PotC: guns fire in a high arc, wide left-right traversing
	// 1: More realistic, direct fire; less left-right traversing possible

bool ALLOW_CRIT_FROM_BALLS = true;
	// Turn on/off the ability to get critical hits while using Balls (like stock game allowed)
	// 1: Yes
	// 0: No

bool ALLOW_FIRE_FROM_BALLS = true;
	// Turn on/off the ability to set a ship on fire while using Balls (like stock game allowed).
	// 1: Yes
	// 0: No

bool EXTRA_HIT_CHECK = true;
	// Enable stray shot hits on friendly ships to cause hostility
	// USE_REAL_CANNONS must be set to 1 for this setting to take effect
	// 1: Yes, when a ship is hit, reduce relation to you
	// 0: No, accidental hits won't cause hostilities

bool CANNONPOWDER_MOD = true;
	// 0: Stock PotC: no gunpowder required for ship guns
	// 1: You must have gunpowder in your CARGO HOLD to charge SHIPGUNS
	// (Not to be confused with the PERSONAL ITEM gunpowder for PISTOLS)


// ======================================
// SHIP MANAGEMENT, REPAIRS, TRADING:
// ======================================

bool FOOD_ON = true;
	// 1: The crew requires food (wheat) and drink (rum) to stay alive and happy
	// 0: Off, stock PotC

bool AUTOHIRECREW_ONCHANGESHIP = true;
	// 1: Automatically hire extra crew when repairing your ship or buying a new one at shipyard
	// 0: Off, stock PotC

bool SY_RPG_STYLE = true;
	// 1: Shipyards will not sell outclassed ships to low level players
	// 0: Stock PotC: all shiptypes may be sold

bool REALISTIC_SHIP_PURCHASE = true;
	// 1: No ships larger than frigates can be purchased but need to be captured instead
	//    This because ships of the line, etc, were never sold, especially not to privateers.
	// 0: No additional limits on buying ships
	// You can tweak this mod to your liking in InternalSettings.h

bool IT_RPG_STYLE = true;
	// 1: Traders will not have items that are too good for the player
	// 0: Traders will have items based on their own random level. Players can buy VERY good items at the beginning of the game

int SALARY_MULTIPLIER = 3;
	// Multiplier for Crew and Officer salary. 1 is Stock POTC. 4 and above makes a more interesting and challenging game.

// ======================================
// LAND FIGHT MODS:
// ======================================

bool CANNOT_RELOAD_WHILE_FIGHTING = true;
	// 1: Your gun won't reload gun while your sword is drawn
	// 0: Stock PotC: Gun will always reload

bool ENABLE_AMMOMOD = true;
	// 0: Stock PotC: no ammunition required for handheld guns
	// 1: You must have gunpowder and the right type of bullets in your PERSONAL INVENTORY to charge HANDHELD guns
	// (Not to be confused with the CARGO HOLD gunpowder for SHIPGUNS)

int CORPSEMODE = 4;
	// 0: Stock PotC: no bodies laying around, no looting ability
	// 1: Corpses will persist, but will not be manually lootable
	// 2: Corpse persists and can be manually looted of items
	// 	WARNING: Until a body is looted, the body will create an impassible obstacle!
	// 4: Corpses fall to the ground properly, don't obstruct walking and can be looted manually

bool AUTOLOOT_ON = false;
	// 0: No automatic looting of killed characters
	// 1: Blade/Gun/Money of killed enemies is automaticly moved into your inventory
	// (This can be combined with CORPSEMODE 2 as any leftover items not autolooted will be left on the corpse)


// ======================================
// LAND EXPLORATION, LOCATIONS:
// ======================================

float DIALOG_CAMERA = 0.0;
	// 0.1 - 1.0: Camera will be moved to the side during dialog, for full scene viewing
	// 0.0: Stock PotC dialogs

bool ENABLE_BROTHEL = false;
	// 0: Stock PotC: no brothel in QC
	// 1: Brothel location opened; a bit explicit, but in WORDS only

bool ENABLE_BUILDINGSET = true;
	// 0: New towns have the same look as the stock PotC locations
	// 1: "additional" buildings in some new locations

int NO_THEFT = 0;
	// You can now pick pockets. But this is risky, and other thieves may pick YOUR pocket too.
	// 0 - 60 : The higher this value the safer you are from pickpockets
	// Above 30 nobody picks YOUR pocket, above 60 you yourself get no chance to steal

int LOCK_OPEN = 0;
 	// 0- 70: the higher this value the higher your chance of picking the locks of treasurechests
	// Above 66 chests always open, above 33 you won't hurt yourself anymore ;-)

// ======================================
// LOG, LOOKS & EFFECTS:
// ======================================

bool LOC_CAMERA = false;
	// 0: Near doors camera view will stay locked to view FROM player
	// 1: Stock PotC: Near doors camera will swerve and focus ON the playercharacter

int ONSEA_COMPASS = 1;
	// 0: Stock PotC: Compass rose is blue
	// 1: Orange transparent compass
	// 2: Historical brass compass
	// 1: turn on

int DISPLAY_TIME = 1;
	// Show a clock in the upper part of the screen
	// 0: Never show the clock
	// 1: Only if you have a clock equipped
	// 2: Always show the clock

bool DISPLAY_BATTLEINTERFACE = false;
	// Show the BattleInterface compass/chart display
	// 0: Only if you have a compass equipped
	// 1: Depending on the settings in the options menu

bool DISPLAY_MAP_POSITION = false;
	// Display the position of your ship on the Map Interface
	// 0: Only if you have a Sextant and a Chronometer
	// 1: Always display your ship's position

int DEFAULT_SAILS = 1;
	// 0: Stock PotC sails, with emblems
	// 1: Build Default: All ships 'Weathered' sails, no emblems except pure white emblems where historically accurate
	// 2: All ships pure white sails, no emblems except where historically accurate
	// 3: All ships pure white sails, with emblems

int PIRATES_BLACK_SAILS = 0;
	// 0: Pirates use the same sails as DEFAULT_SAILS (set above)
	// 1: Pirates use plain black sails
	// 2: Pirates use emblemed black sails

bool ITEM_REALISM = false;
	// if true : items like rubies, diamonds and inca statuettes give no skill bonuses (books and items like compass etc. still do)
