void KAM_Mutiny()
{
//MAXIMUS: new "Mutiny" -->
	if(GetCrewQuantity(GetMainCharacter())>0)
	{
		Log_SetStringToLog(XI_ConvertString("MUTINY") + "!");
		if(bSeaActive && IsEntity(&worldMap)!=0) { LaunchMutinyScreen(); }
		else { PostEvent("StartMutiny", 2500, "1", 0); }
	}
//MAXIMUS: new "Mutiny" <--
}

string KAM_GetDefaultEmblemedSail(ref char)
{
	ref pchar = GetMainCharacter();
	int st = GetCharacterShipType(char);
	ref shref = GetShipByType(st);
	string tempstring;

// KK -->
	int selected_sails = DEFAULT_SAILS;
	if (selected_sails < 1) selected_sails--;
	if (CheckAttribute(pchar, "Viper_SailsTypeType") == true && sti(char.index) == GetMainCharacterIndex()) selected_sails = sti(pchar.Viper_SailsTypeType);
	if (CheckAttribute(pchar, "Viper_SailsTypeType") == true && IsCompanion(char) == true) selected_sails = sti(pchar.Viper_SailsTypeType);

	// PB: Completely Rewritten -->

	// Default Sail Settings
	switch(selected_sails)
	{
		case 1: // Weathered, no emblems
			if(GetCurrentPeriod() <= PERIOD_THE_SPANISH_MAIN)
				tempstring = "sail_weathered_plain.tga";
			else
				tempstring = "sail_weathered_common.tga";
		break;
		case 2: // Pure White, no emblems
			if(GetCurrentPeriod() <= PERIOD_THE_SPANISH_MAIN)
				tempstring = "sail_purewhite_plain.tga";
			else
				tempstring = "sail_purewhite_common.tga";
		break;
		case 3: // Pure White, with emblems
			tempstring = "sail_purewhite_nation" + char.nation + ".tga";
		break;
		// default, with emblems
			tempstring = "sail_whole_white_nation" + char.nation + ".tga";
	}

	// Additional Sail Settings
	switch(sti(char.nation))
	{
		case SPAIN:
			switch(selected_sails)
			{
				case 1: // Weathered, no emblems (historically accurate!)
					if(GetCurrentPeriod() <= PERIOD_THE_SPANISH_MAIN)
						tempstring = "sail_weathered_nation" + char.nation + ".tga";
				break;
				case 2: // Pure White, no emblems (historically accurate!)
					if(GetCurrentPeriod() <= PERIOD_THE_SPANISH_MAIN)
						tempstring = "sail_purewhite_nation" + char.nation + ".tga";
				break;
			}
		break;
		case PIRATE:
			switch(PIRATES_BLACK_SAILS)
			{
				case 1: // Plain Black
					tempstring = "sail_whole_black_plain.tga";
				break;
				case 2: // Emblemed Black
					if(IsCompanion(char))
					{
						if(!CheckAttribute(pchar,"piratesail")) pchar.piratesail = makeint(rand(QTY_LOGOSAILS_WHOLE_BLACK));
						char.piratesail = pchar.piratesail;
					}
					else
					{
						if(!CheckAttribute(char,"piratesail")) { char.piratesail = makeint(rand(QTY_LOGOSAILS_WHOLE_BLACK)); }
					}
					tempstring = "sail_whole_black_pirate" + sti(char.piratesail) + ".tga";
				break;
			}
		break;
		case PORTUGAL:
			switch(selected_sails)
			{
				case 1: // Weathered, no emblems (historically accurate!)
					if(GetCurrentPeriod() <= PERIOD_THE_SPANISH_MAIN)
						tempstring = "sail_weathered_nation" + char.nation + ".tga";
				break;
				case 2: // Pure White, no emblems (historically accurate!)
					if(GetCurrentPeriod() <= PERIOD_THE_SPANISH_MAIN)
						tempstring = "sail_purewhite_nation" + char.nation + ".tga";
				break;
			}
		break;
		case AMERICA:
			switch(selected_sails)
			{
				case 1: // Weathered, no emblems
				break;
				case 2: // Pure White, no emblems
				break;
				case 3: // Pure White, with emblems (not available!)
					tempstring = "sail_purewhite_common.tga";
				break;
				// default, with emblems (not available!)
					tempstring = "sail_whole_white_plain.tga";
			}
		break;
		case PERSONAL_NATION:
			switch(selected_sails)
			{
				case 1: // Weathered, no emblems
				break;
				case 2: // Pure White, no emblems
				break;
				case 3: // Pure White, with emblems (not available!)
					tempstring = "sail_purewhite_nation10.tga";
				break;
				// default, with emblems
					tempstring = "sail_whole_white_nation10.tga";
			}
		break;
	}

	// PB: Completely Rewritten <--

	if (CheckAttribute(shref, "EmblemedSails.nationFileName")) {
		tempstring = shref.EmblemedSails.nationFileName;		// so if the ship has an emblemed sails type defined in ships_init.c, that takes precedence
	}
	if (GetCharacterIndex(char.id) != GetMainCharacterIndex() && IsCompanion(char) == false && CheckAttribute(char, "Ship.EmblemedSails.nationFileName") == true) {
		tempstring = char.Ship.EmblemedSails.nationFileName;
	}

	if (FindFile("RESOURCE\Textures\ships\sails", "*.tga.tx", tempstring + ".tx") == "") return KAM_GetDefaultNormalSail(char); // KK
// <-- KK

	return tempstring;
}

string KAM_GetDefaultNormalSail(ref char)
{
	int st = GetCharacterShipType(char);
	ref shref = GetShipByType(st);
	string tempstring;

// KK -->
	ref pchar = GetMainCharacter();
	int selected_sails = DEFAULT_SAILS;
	if (selected_sails < 1) selected_sails--;
	if (CheckAttribute(pchar, "Viper_SailsTypeType") == true && sti(char.index) == GetMainCharacterIndex()) selected_sails = sti(pchar.Viper_SailsTypeType);
	if (CheckAttribute(pchar, "Viper_SailsTypeType") == true && IsCompanion(char) == true) selected_sails = sti(pchar.Viper_SailsTypeType);

	// PB: Completely Rewritten -->

	switch(selected_sails)
	{
		case 1: // Weathered, no emblems
			tempstring = "sail_weathered_plain.tga";
		break;
		case 2: // Pure White, no emblems
			tempstring = "sail_purewhite_plain.tga";
		break;
		case 3: // Pure White, with emblems
			tempstring = "sail_purewhite_plain.tga";
		break;
		// default, with emblems
			tempstring = "sail_whole_white_plain.tga";
	}

	// Additional Sail Settings
	switch(sti(char.nation))
	{
		case PIRATE:
			switch(PIRATES_BLACK_SAILS)
			{
				case 1: // Plain Black
					tempstring = "sail_whole_black_plain.tga";
				break;
				case 2: // Emblemed Black
					tempstring = "sail_whole_black_plain.tga";
				break;
			}
		break;
	}

	// PB: Completely Rewritten <--

	if (CheckAttribute(shref, "EmblemedSails.normalTex")) {
		tempstring = shref.EmblemedSails.normalTex;		// so if the ship has a normal sails type defined in ships_init.c (e.g. xebec br), that takes precedence
	}
	if (GetCharacterIndex(char.id) != GetMainCharacterIndex() && IsCompanion(char) == false && CheckAttribute(char, "Ship.EmblemedSails.normalTex")) {
		tempstring = char.Ship.EmblemedSails.normalTex;
	}
// <-- KK

	return tempstring;
}

bool KAM_BuySail(string SailID, string EmblemedSailFile, string NormalSailFile, string SailDesc, bool UseStraightAway)
{
	// SailID: a string used to identify the sail internally (to avoid the player buying the same sail twice, for example). not displayed anywhere in the game.
		// the id should be unique to the sail
		// it should contain something that no other modder is likely to use, e.g. your name ^_^
	// EmblemedSailFile: the full path of the texture for the main (emblemed) sails. should start with "Ships\\Sails\\" and end in ".tga"
	// NormalSailFile: the full path of the texture for the normal (non-emblemed) sails. should start with "Ships\\Sails\\" and end in ".tga"
	// SailDesc: a short description of the sail (shown below the image of the sails on the sail select interface)
	// UseStraightAway: set to 'true' to add the sail and activate it; set to false just to add the sail, so the player can activate later

	ref PChar = GetMainCharacter();
	int oldqty = sti(PChar.BuyableSails.Qty);
	string attributename;

	for(int x; x < oldqty; x++)
	{
		attributename = "sail" + x;
		if (PChar.BuyableSails.(attributename).id == SailID) { return false; }
	}

	attributename = "sail" + oldqty;
	PChar.BuyableSails.Qty = (oldqty + 1);
	PChar.BuyableSails.(attributename).id = sailid;
	PChar.BuyableSails.(attributename).emblemedsail = emblemedsailfile;
	PChar.BuyableSails.(attributename).normalsail = normalsailfile;
	PChar.BuyableSails.(attributename).desc = saildesc;

	if (UseStraightAway)
	{
		pchar.Viper_SailsType = "set";
		pchar.Viper_SailsTypeEmblemedFile = emblemedsailfile;
		pchar.Viper_SailsTypeNormalFile = normalsailfile;
		pchar.Viper_SailsTypeType = 3;
		DeleteAttribute(PChar, "Viper_SailsTypeColour");
		pchar.Viper_SailsTypeDesign = SailID;
		DeleteAttribute(PChar, "Viper_SailsTypeNumber");
	}

	return true;
}

bool KAM_SailHasBeenBought(string SailID)
{
	// returns true if a sail with SailID has already been bought, and false if it hasn't

	if (KAM_GetSailIndex(SailID) == -1) { return false; }
	return true;
}

int KAM_GetSailIndex(string SailID)
{
	// returns the index of the sail with SailID, or -1 if no such sail has been bought

	ref PChar = GetMainCharacter();
	int sailsqty = sti(PChar.BuyableSails.Qty);
	string attributename;

	for(int x; x < sailsqty; x++)
	{
		attributename = "sail" + x;
		if (PChar.BuyableSails.(attributename).id == SailID) { return x; }
	}

	return -1;
}


