void relations_init()
{
	ref PChar = GetMainCharacter();

	trace("running qcase beg");

	// Set Pirate Relations
	SetRMRelation(PChar, PIRATE, REL_WAR);
	SetNationRelationBoth(ENGLAND, PIRATE, RELATION_ENEMY);
	SetNationRelationBoth(PORTUGAL, PIRATE, RELATION_ENEMY);
	SetNationRelationBoth(HOLLAND, PIRATE, RELATION_ENEMY);
	SetNationRelationBoth(FRANCE, PIRATE, RELATION_ENEMY);
	SetNationRelationBoth(SPAIN, PIRATE, RELATION_ENEMY);
	if(bUSAExists) SetNationRelationBoth(AMERICA, PIRATE, RELATION_ENEMY);

	// Set Nation Relations
	switch(GetCurrentPeriod())
	{
		case PERIOD_EARLY_EXPLORERS:
			SetNationRelationBoth(ENGLAND, HOLLAND,  RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, SPAIN,    RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(FRANCE,  SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(FRANCE,  PORTUGAL, RELATION_NEUTRAL);
			SetNationRelationBoth(SPAIN,   PORTUGAL, RELATION_FRIEND);
		break;

		case PERIOD_THE_SPANISH_MAIN:
			SetNationRelationBoth(ENGLAND, HOLLAND,  RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, FRANCE,   RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, FRANCE,   RELATION_FRIEND);
			SetNationRelationBoth(HOLLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(FRANCE,  SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(FRANCE,  PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(SPAIN,   PORTUGAL, RELATION_ENEMY);
		break;

		case PERIOD_GOLDEN_AGE_OF_PIRACY:
			SetNationRelationBoth(ENGLAND, HOLLAND,  RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, PORTUGAL, RELATION_FRIEND);
			SetNationRelationBoth(HOLLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, PORTUGAL, RELATION_FRIEND);
			SetNationRelationBoth(FRANCE,  SPAIN,    RELATION_FRIEND);
			SetNationRelationBoth(FRANCE,  PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(SPAIN,   PORTUGAL, RELATION_ENEMY);
		break;

		case PERIOD_COLONIAL_POWERS:
			SetNationRelationBoth(ENGLAND, HOLLAND,  RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, PORTUGAL, RELATION_FRIEND);
			SetNationRelationBoth(HOLLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, PORTUGAL, RELATION_NEUTRAL);
			SetNationRelationBoth(FRANCE,  SPAIN,    RELATION_FRIEND);
			SetNationRelationBoth(FRANCE,  PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(SPAIN,   PORTUGAL, RELATION_ENEMY);
		break;

		case PERIOD_REVOLUTIONS:
			SetNationRelationBoth(ENGLAND, HOLLAND,  RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, PORTUGAL, RELATION_NEUTRAL);
			SetNationRelationBoth(ENGLAND, AMERICA,  RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, FRANCE,   RELATION_FRIEND);
			SetNationRelationBoth(HOLLAND, SPAIN,    RELATION_FRIEND);
			SetNationRelationBoth(HOLLAND, PORTUGAL, RELATION_NEUTRAL);
			SetNationRelationBoth(HOLLAND, AMERICA,  RELATION_FRIEND);
			SetNationRelationBoth(FRANCE,  SPAIN,    RELATION_FRIEND);
			SetNationRelationBoth(FRANCE,  PORTUGAL, RELATION_NEUTRAL);
			SetNationRelationBoth(FRANCE,  AMERICA,  RELATION_FRIEND);
			SetNationRelationBoth(SPAIN,   PORTUGAL, RELATION_NEUTRAL);
			SetNationRelationBoth(SPAIN,   AMERICA,  RELATION_FRIEND);
			SetNationRelationBoth(AMERICA, PORTUGAL, RELATION_NEUTRAL);
		break;

		case PERIOD_NAPOLEONIC:
			SetNationRelationBoth(ENGLAND, HOLLAND,  RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, FRANCE,   RELATION_ENEMY);
			SetNationRelationBoth(ENGLAND, SPAIN,    RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, PORTUGAL, RELATION_FRIEND);
			SetNationRelationBoth(ENGLAND, AMERICA,  RELATION_NEUTRAL);
			SetNationRelationBoth(HOLLAND, FRANCE,   RELATION_FRIEND);
			SetNationRelationBoth(HOLLAND, SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(HOLLAND, AMERICA,  RELATION_FRIEND);
			SetNationRelationBoth(FRANCE,  SPAIN,    RELATION_ENEMY);
			SetNationRelationBoth(FRANCE,  PORTUGAL, RELATION_ENEMY);
			SetNationRelationBoth(FRANCE,  AMERICA,  RELATION_NEUTRAL);
			SetNationRelationBoth(SPAIN,   PORTUGAL, RELATION_FRIEND);
			SetNationRelationBoth(SPAIN,   AMERICA,  RELATION_ENEMY);
			SetNationRelationBoth(AMERICA, PORTUGAL, RELATION_FRIEND);
		break;
	}

	if (ENABLE_FLAGS == 1) {
		LooseLetterOfMarque(ENGLAND);
		LooseLetterOfMarque(FRANCE);
		LooseLetterOfMarque(SPAIN);
		LooseLetterOfMarque(HOLLAND);
		LooseLetterOfMarque(PORTUGAL);
		if(bUSAExists) LooseLetterOfMarque(AMERICA);

		SetActualRMRelation(ENGLAND, GetRMRelation(PChar, ENGLAND));
		SetActualRMRelation(FRANCE, GetRMRelation(PChar, FRANCE));
		SetActualRMRelation(SPAIN, GetRMRelation(PChar, SPAIN));
		SetActualRMRelation(PIRATE, GetRMRelation(PChar, PIRATE));
		SetActualRMRelation(HOLLAND, GetRMRelation(PChar, HOLLAND));
		SetActualRMRelation(PORTUGAL, GetRMRelation(PChar, PORTUGAL));
		if(bUSAExists) SetActualRMRelation(AMERICA, GetRMRelation(PChar, AMERICA));
	}
	UpdateRelations();
}
