#define PERIOD_EARLY_EXPLORERS			0
#define PERIOD_THE_SPANISH_MAIN			1
#define PERIOD_GOLDEN_AGE_OF_PIRACY		2
#define PERIOD_COLONIAL_POWERS			3
#define PERIOD_REVOLUTIONS				4
#define PERIOD_NAPOLEONIC				5

#define MAX_PERIODS						6

object Periods[MAX_PERIODS];

int PeriodsQuantity = 0;

void InitPeriods()
{
	ref period;
	int n = 0;

	for (n = 0; n < MAX_PERIODS; n++) {
		makeref(period, Periods[n]);
		DeleteAttribute(period, "");
		period.id = "Period" + n;
		period.name = "";
		period.date.start = "";
		period.date.end = "";
	}

	n = 0;

	makeref(period, Periods[n]);
	period.name = "Early Explorers";
	period.date.start = "1500";
	period.date.end = "1599";
	n++;

	makeref(period, Periods[n]);
	period.name = "The Spanish Main";
	period.date.start = "1600";
	period.date.end = "1679";
	n++;

	makeref(period, Periods[n]);
	period.name = "Golden Age of Piracy";
	period.date.start = "1680";
	period.date.end = "1739";
	n++;

	makeref(period, Periods[n]);
	period.name = "Colonial Powers";
	period.date.start = "1740";
	period.date.end = "1769";
	n++;

	makeref(period, Periods[n]);
	period.name = "Revolutions";
	period.date.start = "1770";
	period.date.end = "1789";
	n++;

	makeref(period, Periods[n]);
	period.name = "Napoleonic";
	period.date.start = "1790";
	period.date.end = "1830";
	n++;

	PeriodsQuantity = n;
}

string GetPeriodName(int idx)
{
	if (idx < 0 || idx >= PeriodsQuantity) return "";
	ref period; makeref(period, Periods[idx]);
	if (!CheckAttribute(period, "name")) return "";
	return period.name;
}

int GetPeriodFromYear(int year)
{
	ref period;
	for (int i = 0; i < PeriodsQuantity; i++) {
		makeref(period, Periods[i]);
		if (sti(period.date.start) <= year && sti(period.date.end) >= year) return i;
	}
	return -1;
}

int GetCurrentPeriod()
{
	ref period; makeref(period, Periods[0]);
	if (!CheckAttribute(period, "current")) return PERIOD_GOLDEN_AGE_OF_PIRACY;
	return sti(period.current);
}

void SetCurrentPeriod(int cperiod)
{
	ref period; makeref(period, Periods[0]);
	if(cperiod < 0 || cperiod >= MAX_PERIODS) period.current = PERIOD_GOLDEN_AGE_OF_PIRACY;
	else period.current = cperiod;
}

// PB -->
void InitTownNationalities()
{
	switch(GetCurrentPeriod())
	{
		case PERIOD_EARLY_EXPLORERS:
			// Grenada (Conceicao), Sao Jorge:
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].name = "Gonzalo";
					DeleteAttribute(CharacterFromID("Jacinto Arcibaldo Barreto"),"middlename");
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].lastname = "de Guzmn";
			// Bonaire (Douwesen), Kralendijk:
					SetTown2Nation("Douwesen", SPAIN); // Palo Brasil
					Characters[GetCharacterIndex("Reynard Grueneveldt")].name = "Juan";
					Characters[GetCharacterIndex("Reynard Grueneveldt")].lastname = "de vila";
			// Martinique (Falaise de Fleur), St Pierre:
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].name = "Antonio";
					DeleteAttribute(CharacterFromID("Joseph Claude Le Moigne"),"middlename");
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].lastname = "de Chves";
			// Puerto Rico (Isla Muelle), San Juan:
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].name = "Juan";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].middlename = "Ponce";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].lastname = "de Len";
			// Barbados (Oxbay), Speightstown:
					SetTown2Nation("Oxbay", PORTUGAL); // So Luis
			// Barbados (Oxbay), Bridgetown:
					SetTown2Nation("Greenford", PORTUGAL); // Santa Ins
			// Jamaica (Redmond), Port Royale:
					SetTown2Nation("Redmond", SPAIN); // Villa de la Vega
					Characters[GetCharacterIndex("John Clifford Brin")].name = "Juan";
					DeleteAttribute(CharacterFromID("John Clifford Brin"),"middlename");
					Characters[GetCharacterIndex("John Clifford Brin")].lastname = "de Esquivel";
			// Nevis (Quebradas Costillas), Charlestown:
					SetTown2Nation("Charlestown", SPAIN); // Pueblo Carlos
					Characters[GetCharacterIndex("Thomas Modiford")].name = "Gonzalo";
					Characters[GetCharacterIndex("Thomas Modiford")].middlename = "Prez";
					Characters[GetCharacterIndex("Thomas Modiford")].lastname = "de Angulo";
			// Hispaniola, Port au Prince:
					SetTown2Nation("Port au Prince", SPAIN); // Santa Maria del Puerto
					Characters[GetCharacterIndex("Isabelle de Cussy")].name = "Nicols";
					DeleteAttribute(CharacterFromID("Isabelle de Cussy"),"middlename");
					Characters[GetCharacterIndex("Isabelle de Cussy")].lastname = "de Ovando";
			// Hispaniola, Santo Domingo:
					Characters[GetCharacterIndex("Salvador Allende")].name = "Diego";
					Characters[GetCharacterIndex("Salvador Allende")].lastname = "Columbus";
			// Hispaniola, Tortuga:
					SetTown2Nation("Tortuga", FRANCE);
			// Turks, Grand Turk:
					Characters[GetCharacterIndex("Dante Siciliano")].name = "Diego";
					Characters[GetCharacterIndex("Dante Siciliano")].lastname = "de Mazariegos";
			// Cayman, Grand Cayman:
					SetTown2Nation("Grand Cayman", SPAIN); // Cumana
					Characters[GetCharacterIndex("Edmund Christobel Shaw")].name = "Francisco";
					Characters[GetCharacterIndex("Edmund Christobel Shaw")].middlename = "Garca";
					Characters[GetCharacterIndex("Edmund Christobel Shaw")].lastname = "Osorio";
			// Cuba, Havana:
					Characters[GetCharacterIndex("Felipe Cisneros")].name = "Hernando";
					Characters[GetCharacterIndex("Felipe Cisneros")].lastname = "de Soto";
			// Cuba, Santiago:
					Characters[GetCharacterIndex("Javier Balboa")].name = "Pedro";
					Characters[GetCharacterIndex("Javier Balboa")].middlename = "Menndez";
					Characters[GetCharacterIndex("Javier Balboa")].lastname = "de Avils";
			// Guadeloupe, Pointe a Pitre:
					Characters[GetCharacterIndex("Remy Gatien_gov")].name = "Gabriel";
					DeleteAttribute(CharacterFromID("Remy Gatien_gov"),"middlename");
					Characters[GetCharacterIndex("Remy Gatien_gov")].lastname = "Montalvo";
			// Saint Martin, Marigot:
			//		SetTown2Nation("Marigot", SPAIN);
			//		Characters[GetCharacterIndex("Arendt Dickman")].name = "";
			//		Characters[GetCharacterIndex("Arendt Dickman")].lastname = "";
			// Saint Martin, Philipsburg:
			//		SetTown2Nation("Philipsburg", SPAIN);
			//		Characters[GetCharacterIndex("Philippe de Rivarol")].name = "";
			//		Characters[GetCharacterIndex("Philippe de Rivarol")].lastname = "";
			// Antigua, St John's:
			//		SetTown2Nation("St John's", SPAIN);
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].name = "";
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].lastname = "";
			// Curacao, Willemstad:
			//		SetTown2Nation("Willemstad", SPAIN);
			//		Characters[GetCharacterIndex("Hans Kloss")].name = "";
			//		Characters[GetCharacterIndex("Hans Kloss")].lastname = "";
			// Eleuthera, Governor's Harbor:
					SetTown2Nation("Eleuthera", SPAIN); // Puerto la Cruz
					Characters[GetCharacterIndex("Cole Arkwright")].name = "Francisco";
					Characters[GetCharacterIndex("Cole Arkwright")].lastname = "Carreo";
			// Eleuthera, Alice Town:
					SetTown2Nation("Alice", SPAIN); // San Elena
					Characters[GetCharacterIndex("Michael Wainwright")].name = "Gaspar";
					Characters[GetCharacterIndex("Michael Wainwright")].lastname = "de Torres";
			// Aruba, Oranjestad
			//		SetTown2Nation("Oranjestad", SPAIN);
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].name = "";
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].lastname = "";
		break;

		case PERIOD_THE_SPANISH_MAIN:
			// Grenada (Conceicao), Sao Jorge:
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].name = "Francisco";
					DeleteAttribute(CharacterFromID("Jacinto Arcibaldo Barreto"),"middlename");
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].lastname = "de Venegas";
			// Bonaire (Douwesen), Kralendijk:
			//		SetTown2Nation("Douwesen", SPAIN); // Palo Brasil
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].name = "Diego";
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].lastname = "Rangel";
			// Martinique (Falaise de Fleur), St Pierre:
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].name = "Francisco";
					DeleteAttribute(CharacterFromID("Joseph Claude Le Moigne"),"middlename");
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].lastname = "Terril";
			// Puerto Rico (Isla Muelle), San Juan:
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].name = "Sancho";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].middlename = "Ochoa";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].lastname = "de Castro";
			// Barbados (Oxbay), Speightstown:
			// Barbados (Oxbay), Bridgetown:
			// Jamaica (Redmond), Port Royale:
					Characters[GetCharacterIndex("John Clifford Brin")].name = "Sir George";
					DeleteAttribute(CharacterFromID("John Clifford Brin"),"middlename");
					Characters[GetCharacterIndex("John Clifford Brin")].lastname = "Ayscue";
			// Nevis (Quebradas Costillas), Charlestown:
					Characters[GetCharacterIndex("Thomas Modiford")].name = "Anthony";
					Characters[GetCharacterIndex("Thomas Modiford")].lastname = "Hilton";
			// Hispaniola, Port au Prince:
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].name = "";
			//		DeleteAttribute(CharacterFromID("Isabelle de Cussy"),"middlename");
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].lastname = "";
			// Hispaniola, Santo Domingo:
					Characters[GetCharacterIndex("Salvador Allende")].name = "Juan";
					Characters[GetCharacterIndex("Salvador Allende")].middlename = "de Montanos";
					Characters[GetCharacterIndex("Salvador Allende")].lastname = "Blzquez";
			// Hispaniola, Tortuga:
					SetTown2Nation("Tortuga", FRANCE);
			// Turks, Grand Turk:
					Characters[GetCharacterIndex("Dante Siciliano")].name = "Juan";
					Characters[GetCharacterIndex("Dante Siciliano")].lastname = "de Salamanca";
			// Cayman, Grand Cayman:
					Characters[GetCharacterIndex("Edmund Christobel Shaw")].name = "Francisco";
					DeleteAttribute(CharacterFromID("Edmund Christobel Shaw"),"middlename");
					Characters[GetCharacterIndex("Edmund Christobel Shaw")].lastname = "Xelder";
			// Cuba, Havana:
					Characters[GetCharacterIndex("Felipe Cisneros")].name = "Pedro";
					Characters[GetCharacterIndex("Felipe Cisneros")].lastname = "Vads";
			// Cuba, Santiago:
					Characters[GetCharacterIndex("Javier Balboa")].name = "Gaspar";
					Characters[GetCharacterIndex("Javier Balboa")].middlename = "Ruz";
					Characters[GetCharacterIndex("Javier Balboa")].lastname = "de Pereda";
			// Guadeloupe, Pointe a Pitre:
					Characters[GetCharacterIndex("Remy Gatien_gov")].name = "Jos";
					Characters[GetCharacterIndex("Remy Gatien_gov")].middlename = "Fernandez";
					Characters[GetCharacterIndex("Remy Gatien_gov")].lastname = "Crdoba";
			// Saint Martin, Marigot:
			//		Characters[GetCharacterIndex("Arendt Dickman")].name = "";
			//		Characters[GetCharacterIndex("Arendt Dickman")].lastname = "";
			// Saint Martin, Philipsburg:
			//		Characters[GetCharacterIndex("Philippe de Rivarol")].name = "";
			//		Characters[GetCharacterIndex("Philippe de Rivarol")].lastname = "";
			// Antigua, St John's:
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].name = "";
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].lastname = "";
			// Curacao, Willemstad:
			//		Characters[GetCharacterIndex("Hans Kloss")].name = "";
			//		Characters[GetCharacterIndex("Hans Kloss")].lastname = "";
			// Eleuthera, Governor's Harbor:
					SetTown2Nation("Eleuthera", SPAIN); // Puerto la Cruz
					Characters[GetCharacterIndex("Cole Arkwright")].name = "Francis";
					Characters[GetCharacterIndex("Cole Arkwright")].lastname = "Willoughby";
			// Eleuthera, Alice Town:
			//		Characters[GetCharacterIndex("Michael Wainwright")].name = "";
			//		Characters[GetCharacterIndex("Michael Wainwright")].lastname = "";
			// Aruba, Oranjestad
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].name = "";
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].lastname = "";
		break;

		case PERIOD_GOLDEN_AGE_OF_PIRACY:
			// Grenada (Conceicao), Sao Jorge:
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].name = "Joseph";
					DeleteAttribute(CharacterFromID("Jacinto Arcibaldo Barreto"),"middlename");
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].lastname = "de Bouloc";
			// Bonaire (Douwesen), Kralendijk:
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].name = "";
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].lastname = "";
			// Martinique (Falaise de Fleur), St Pierre:
			//		Characters[GetCharacterIndex("Joseph Claude Le Moigne")].name = "";
			//		DeleteAttribute(CharacterFromID("Joseph Claude Le Moigne"),"middlename");
			//		Characters[GetCharacterIndex("Joseph Claude Le Moigne")].lastname = "";
			// Puerto Rico (Isla Muelle), San Juan:
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].name = "Juan";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].middlename = "Francisco";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].lastname = "Medina";
			// Barbados (Oxbay), Speightstown:
			// Barbados (Oxbay), Bridgetown:
			// Jamaica (Redmond), Port Royale:
					Characters[GetCharacterIndex("John Clifford Brin")].name = "Sir Henry";
					DeleteAttribute(CharacterFromID("John Clifford Brin"),"middlename");
					Characters[GetCharacterIndex("John Clifford Brin")].lastname = "Morgan";
					Characters[GetCharacterIndex("John Clifford Brin")].model = "Henry_Morgan";
			// Nevis (Quebradas Costillas), Charlestown:
					Characters[GetCharacterIndex("Thomas Modiford")].name = "Sir William";
					Characters[GetCharacterIndex("Thomas Modiford")].lastname = "Stapleton";
			// Hispaniola, Port au Prince:
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].name = "";
			//		DeleteAttribute(CharacterFromID("Isabelle de Cussy"),"middlename");
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].lastname = "";
			// Hispaniola, Santo Domingo:
					Characters[GetCharacterIndex("Salvador Allende")].name = "Juan";
					Characters[GetCharacterIndex("Salvador Allende")].middlename = "Maldonaldo";
					Characters[GetCharacterIndex("Salvador Allende")].lastname = "Barnuevo";
			// Hispaniola, Tortuga:
					SetTown2Nation("Tortuga", FRANCE);
			// Turks, Grand Turk:
					Characters[GetCharacterIndex("Dante Siciliano")].name = "Juan";
					Characters[GetCharacterIndex("Dante Siciliano")].lastname = "de Tejeda";
			// Cayman, Grand Cayman:
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].name = "";
			//		DeleteAttribute(CharacterFromID("Edmund Christobel Shaw"),"middlename");
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].lastname = "";
			// Cuba, Havana:
					Characters[GetCharacterIndex("Felipe Cisneros")].name = "Vicente";
					Characters[GetCharacterIndex("Felipe Cisneros")].lastname = "de Raja";
			// Cuba, Santiago:
					Characters[GetCharacterIndex("Javier Balboa")].name = "Dionisio";
					Characters[GetCharacterIndex("Javier Balboa")].middlename = "Martnez";
					Characters[GetCharacterIndex("Javier Balboa")].lastname = "de la Vega";
			// Guadeloupe, Pointe a Pitre:
			//		Characters[GetCharacterIndex("Remy Gatien_gov")].name = "";
			//		Characters[GetCharacterIndex("Remy Gatien_gov")].middlename = "";
			//		Characters[GetCharacterIndex("Remy Gatien_gov")].lastname = "";
			// Saint Martin, Marigot:
					Characters[GetCharacterIndex("Philippe de Rivarol")].name = "Chevalier";
					Characters[GetCharacterIndex("Philippe de Rivarol")].middlename = "Martnez";
					Characters[GetCharacterIndex("Philippe de Rivarol")].lastname = "de Rionville";
			// Saint Martin, Philipsburg:
					Characters[GetCharacterIndex("Arendt Dickman")].name = "Jan";
					Characters[GetCharacterIndex("Arendt Dickman")].middlename = "Simonszoon";
					Characters[GetCharacterIndex("Arendt Dickman")].lastname = "de Buck";
			// Antigua, St John's:
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].name = "";
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].lastname = "";
			// Curacao, Willemstad:
			//		Characters[GetCharacterIndex("Hans Kloss")].name = "";
			//		Characters[GetCharacterIndex("Hans Kloss")].lastname = "";
			// Eleuthera, Governor's Harbor:
					Characters[GetCharacterIndex("Cole Arkwright")].name = "Sir John";
					Characters[GetCharacterIndex("Cole Arkwright")].lastname = "Witham";
			// Eleuthera, Alice Town:
					Characters[GetCharacterIndex("Michael Wainwright")].name = "Sir Richard";
					Characters[GetCharacterIndex("Michael Wainwright")].lastname = "Dutton";
			// Aruba, Oranjestad
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].name = "";
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].lastname = "";
		break;

		case PERIOD_COLONIAL_POWERS:
			// Grenada (Conceicao), Sao Jorge:
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].name = "Gabriel";
					DeleteAttribute(CharacterFromID("Jacinto Arcibaldo Barreto"),"middlename");
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].lastname = "de Lujn";
			// Bonaire (Douwesen), Kralendijk:
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].name = "";
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].lastname = "";
			// Martinique (Falaise de Fleur), St Pierre:
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].lastname = "Le Moigne II";
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].model = "huber_Fra3_17"; // Thomas the Terror
			// Puerto Rico (Isla Muelle), San Juan:
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].name = "Juan";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].middlename = "Jos";
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].lastname = "Colomo";
			// Barbados (Oxbay), Speightstown:
			// Barbados (Oxbay), Bridgetown:
			// Jamaica (Redmond), Port Royale:
					if(GetStoryline(FindCurrentStoryline()) != "LegendJackSparrow" )
					{	// PB: This interferes with the Brin/Brinkley aspect of the Jack Sparrow story
						Characters[GetCharacterIndex("John Clifford Brin")].name = "Sir Henry";
						DeleteAttribute(CharacterFromID("John Clifford Brin"),"middlename");
						Characters[GetCharacterIndex("John Clifford Brin")].lastname = "Moore";
					}
			// Nevis (Quebradas Costillas), Charlestown:
					Characters[GetCharacterIndex("Thomas Modiford")].name = "Michael";
					Characters[GetCharacterIndex("Thomas Modiford")].lastname = "Smith";
			// Hispaniola, Port au Prince:
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].name = "";
			//		DeleteAttribute(CharacterFromID("Isabelle de Cussy"),"middlename");
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].lastname = "";
			// Hispaniola, Santo Domingo:
					SetTown2Nation("Santo Domingo", FRANCE);
					Characters[GetCharacterIndex("Salvador Allende")].name = "Longvilliers";
					Characters[GetCharacterIndex("Salvador Allende")].lastname = "de Poincy";
			// Hispaniola, Tortuga:
			//		SetTown2Nation("Tortuga", FRANCE);
			// Turks, Grand Turk:
			//		Characters[GetCharacterIndex("Dante Siciliano")].name = "";
			//		Characters[GetCharacterIndex("Dante Siciliano")].lastname = "";
			// Cayman, Grand Cayman:
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].name = "";
			//		DeleteAttribute(CharacterFromID("Edmund Christobel Shaw"),"middlename");
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].lastname = "";
			// Cuba, Havana:
					Characters[GetCharacterIndex("Felipe Cisneros")].name = "Juan";
					Characters[GetCharacterIndex("Felipe Cisneros")].middlename = "de Prado Mayera Portocarrero";
					Characters[GetCharacterIndex("Felipe Cisneros")].lastname = "y Luna";
			// Cuba, Santiago:
					Characters[GetCharacterIndex("Javier Balboa")].name = "Francisco";
					Characters[GetCharacterIndex("Javier Balboa")].middlename = "Antonio Cagigal";
					Characters[GetCharacterIndex("Javier Balboa")].lastname = "de la Vega";
			// Guadeloupe, Pointe a Pitre:
					Characters[GetCharacterIndex("Remy Gatien_gov")].name = "Gabriel";
					Characters[GetCharacterIndex("Remy Gatien_gov")].middlename = "d'Erchigny";
					Characters[GetCharacterIndex("Remy Gatien_gov")].lastname = "de Clieu";
			// Saint Martin, Marigot:
					Characters[GetCharacterIndex("Philippe de Rivarol")].name = "Louis";
					Characters[GetCharacterIndex("Philippe de Rivarol")].middlename = "Guillaume";
					Characters[GetCharacterIndex("Philippe de Rivarol")].lastname = "Durepaire";
			// Saint Martin, Philipsburg:
					Characters[GetCharacterIndex("Arendt Dickman")].name = "Jan";
					Characters[GetCharacterIndex("Arendt Dickman")].lastname = "de Wever";
			// Antigua, St John's:
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].name = "";
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].lastname = "";
			// Curacao, Willemstad:
			//		Characters[GetCharacterIndex("Hans Kloss")].name = "";
			//		Characters[GetCharacterIndex("Hans Kloss")].lastname = "";
			// Eleuthera, Governor's Harbor:
					Characters[GetCharacterIndex("Cole Arkwright")].name = "Sir Thomas";
					Characters[GetCharacterIndex("Cole Arkwright")].lastname = "Robinson";
			// Eleuthera, Alice Town:
					Characters[GetCharacterIndex("Michael Wainwright")].name = "Henry";
					Characters[GetCharacterIndex("Michael Wainwright")].lastname = "Grenville";
			// Aruba, Oranjestad
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].name = "";
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].lastname = "";
		break;

		case PERIOD_REVOLUTIONS:
			// Grenada (Conceicao), Sao Jorge:
					SetTown2Nation("Conceicao", ENGLAND); // Saint George
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].name = "Samuel";
					DeleteAttribute(CharacterFromID("Jacinto Arcibaldo Barreto"),"middlename");
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].lastname = "Mitchell";
			// Bonaire (Douwesen), Kralendijk:
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].name = "";
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].lastname = "";
			// Martinique (Falaise de Fleur), St Pierre:
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].name = "Ulysses";
					DeleteAttribute(CharacterFromID("Joseph Claude Le Moigne"),"middlename");
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].lastname = "FitzMaurice";
			// Puerto Rico (Isla Muelle), San Juan:
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].name = "Miguel ";
					DeleteAttribute(CharacterFromID("Christofor Manuel De Alencar"),"middlename");
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].lastname = "de Musesas";
			// Barbados (Oxbay), Speightstown:
			// Barbados (Oxbay), Bridgetown:
			// Jamaica (Redmond), Port Royale:
					Characters[GetCharacterIndex("John Clifford Brin")].name = "Sir John";
					DeleteAttribute(CharacterFromID("John Clifford Brin"),"middlename");
					Characters[GetCharacterIndex("John Clifford Brin")].lastname = "Dalling";
			// Nevis (Quebradas Costillas), Charlestown:
					Characters[GetCharacterIndex("Thomas Modiford")].name = "Joseph";
					Characters[GetCharacterIndex("Thomas Modiford")].middlename = "Richardson";
					Characters[GetCharacterIndex("Thomas Modiford")].lastname = "Herbert";
			// Hispaniola, Port au Prince:
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].name = "";
			//		DeleteAttribute(CharacterFromID("Isabelle de Cussy"),"middlename");
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].lastname = "";
			// Hispaniola, Santo Domingo:
					SetTown2Nation("Santo Domingo", FRANCE);
					Characters[GetCharacterIndex("Salvador Allende")].name = "Jean";
					Characters[GetCharacterIndex("Salvador Allende")].lastname = "Dotin";
			// Hispaniola, Tortuga:
					SetTown2Nation("Tortuga", FRANCE);
			// Turks, Grand Turk:
					SetTown2Nation("Grand Turk", ENGLAND);
					Characters[GetCharacterIndex("Dante Siciliano")].name = "Daniel";
					Characters[GetCharacterIndex("Dante Siciliano")].lastname = "Sicilian";
			// Cayman, Grand Cayman:
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].name = "";
			//		DeleteAttribute(CharacterFromID("Edmund Christobel Shaw"),"middlename");
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].lastname = "";
			// Cuba, Havana:
					Characters[GetCharacterIndex("Felipe Cisneros")].name = " Jos";
					Characters[GetCharacterIndex("Felipe Cisneros")].middlename = "Manuel";
					Characters[GetCharacterIndex("Felipe Cisneros")].lastname = "de Ezpeleta";
			// Cuba, Santiago:
					Characters[GetCharacterIndex("Javier Balboa")].name = "Domingo";
					Characters[GetCharacterIndex("Javier Balboa")].middlename = "Cabello";
					Characters[GetCharacterIndex("Javier Balboa")].lastname = "y Robles";
			// Guadeloupe, Pointe a Pitre:
					Characters[GetCharacterIndex("Remy Gatien_gov")].name = "Louis";
					Characters[GetCharacterIndex("Remy Gatien_gov")].middlename = "Franois";
					Characters[GetCharacterIndex("Remy Gatien_gov")].lastname = "de Dion";
			// Saint Martin, Marigot:
					Characters[GetCharacterIndex("Philippe de Rivarol")].name = "Louis";
					Characters[GetCharacterIndex("Philippe de Rivarol")].middlename = "Guillaume";
					Characters[GetCharacterIndex("Philippe de Rivarol")].lastname = "Durepaire";
			// Saint Martin, Philipsburg:
					Characters[GetCharacterIndex("Arendt Dickman")].name = "Jan";
					Characters[GetCharacterIndex("Arendt Dickman")].lastname = "de Wever";
			// Antigua, St John's:
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].name = "";
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].lastname = "";
			// Curacao, Willemstad:
			//		Characters[GetCharacterIndex("Hans Kloss")].name = "";
			//		Characters[GetCharacterIndex("Hans Kloss")].lastname = "";
			// Eleuthera, Governor's Harbor:
					CaptureTownForNation("Eleuthera", AMERICA);
					Towns[GetTownIndex("Eleuthera")].homeland = AMERICA;
			//		Characters[GetCharacterIndex("Cole Arkwright")].name = "";
			//		Characters[GetCharacterIndex("Cole Arkwright")].lastname = "";
			// Eleuthera, Alice Town:
					CaptureTownForNation("Alice", AMERICA);
					Towns[GetTownIndex("Alice")].homeland = AMERICA;
					Characters[GetCharacterIndex("Michael Wainwright")].name = "James";
					Characters[GetCharacterIndex("Michael Wainwright")].lastname = "Cunninghame";
			// Aruba, Oranjestad
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].name = "";
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].lastname = "";
		break;

		case PERIOD_NAPOLEONIC:
			// Grenada (Conceicao), Sao Jorge:
					SetTown2Nation("Conceicao", ENGLAND); // Saint George
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].name = "Samuel";
					DeleteAttribute(CharacterFromID("Jacinto Arcibaldo Barreto"),"middlename");
					Characters[GetCharacterIndex("Jacinto Arcibaldo Barreto")].lastname = "Mitchell";
			// Bonaire (Douwesen), Kralendijk:
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].name = "";
			//		Characters[GetCharacterIndex("Reynard Grueneveldt")].lastname = "";
			// Martinique (Falaise de Fleur), St Pierre:
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].name = "Louis Thomas";
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].middlename = "Villaret";
					Characters[GetCharacterIndex("Joseph Claude Le Moigne")].lastname = "de Joyeuse";
			// Puerto Rico (Isla Muelle), San Juan:
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].name = "Francisco";
					DeleteAttribute(CharacterFromID("Christofor Manuel De Alencar"),"middlename");
					Characters[GetCharacterIndex("Christofor Manuel De Alencar")].lastname = "Torralbo";
			// Barbados (Oxbay), Speightstown:
			// Barbados (Oxbay), Bridgetown:
			// Jamaica (Redmond), Port Royale:
					Characters[GetCharacterIndex("John Clifford Brin")].name = "Sir George";
					DeleteAttribute(CharacterFromID("John Clifford Brin"),"middlename");
					Characters[GetCharacterIndex("John Clifford Brin")].lastname = "Nugent";
			// Nevis (Quebradas Costillas), Charlestown:
					Characters[GetCharacterIndex("Thomas Modiford")].name = "James";
					Characters[GetCharacterIndex("Thomas Modiford")].lastname = "Daniell";
			// Hispaniola, Port au Prince:
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].name = "";
			//		DeleteAttribute(CharacterFromID("Isabelle de Cussy"),"middlename");
			//		Characters[GetCharacterIndex("Isabelle de Cussy")].lastname = "";
			// Hispaniola, Santo Domingo:
					SetTown2Nation("Santo Domingo", FRANCE);
					Characters[GetCharacterIndex("Salvador Allende")].name = "Jean";
					Characters[GetCharacterIndex("Salvador Allende")].lastname = "Dotin";
			// Hispaniola, Tortuga:
					SetTown2Nation("Tortuga", FRANCE);
			// Turks, Grand Turk:
					SetTown2Nation("Grand Turk", ENGLAND);
					Characters[GetCharacterIndex("Dante Siciliano")].name = "Daniel";
					Characters[GetCharacterIndex("Dante Siciliano")].lastname = "Sicilian";
			// Cayman, Grand Cayman:
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].name = "";
			//		DeleteAttribute(CharacterFromID("Edmund Christobel Shaw"),"middlename");
			//		Characters[GetCharacterIndex("Edmund Christobel Shaw")].lastname = "";
			// Cuba, Havana:
					Characters[GetCharacterIndex("Felipe Cisneros")].name = "Juan";
					Characters[GetCharacterIndex("Felipe Cisneros")].middlename = "Ruz";
					Characters[GetCharacterIndex("Felipe Cisneros")].lastname = "de Apodaca";
			// Cuba, Santiago:
					Characters[GetCharacterIndex("Javier Balboa")].name = "Jos";
					Characters[GetCharacterIndex("Javier Balboa")].lastname = "Cienfuegos";
			// Guadeloupe, Pointe a Pitre:
					Characters[GetCharacterIndex("Remy Gatien_gov")].name = "Victor";
					Characters[GetCharacterIndex("Remy Gatien_gov")].lastname = "Collot";
			// Saint Martin, Marigot:
					Characters[GetCharacterIndex("Philippe de Rivarol")].name = "Louis";
					Characters[GetCharacterIndex("Philippe de Rivarol")].middlename = "Guillaume";
					Characters[GetCharacterIndex("Philippe de Rivarol")].lastname = "Durepaire";
			// Saint Martin, Philipsburg:
			//		Characters[GetCharacterIndex("Arendt Dickman")].name = "";
			//		Characters[GetCharacterIndex("Arendt Dickman")].lastname = "";
			// Antigua, St John's:
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].name = "";
			//		Characters[GetCharacterIndex("Antigua_Portadmiral")].lastname = "";
			// Curacao, Willemstad:
			//		Characters[GetCharacterIndex("Hans Kloss")].name = "";
			//		Characters[GetCharacterIndex("Hans Kloss")].lastname = "";
			// Eleuthera, Governor's Harbor:
					CaptureTownForNation("Eleuthera", AMERICA);
					Towns[GetTownIndex("Eleuthera")].homeland = AMERICA;
					Characters[GetCharacterIndex("Cole Arkwright")].name = "William";
					Characters[GetCharacterIndex("Cole Arkwright")].lastname = "Bishop";
			// Eleuthera, Alice Town:
					CaptureTownForNation("Alice", AMERICA);
					Towns[GetTownIndex("Alice")].homeland = AMERICA;
					Characters[GetCharacterIndex("Michael Wainwright")].name = "Francis";
					Characters[GetCharacterIndex("Michael Wainwright")].middlename = "Humberstone";
					Characters[GetCharacterIndex("Michael Wainwright")].lastname = "Mackenzie";
			// Aruba, Oranjestad
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].name = "";
			//		Characters[GetCharacterIndex("Hendrick van der Kuylen")].lastname = "";
		break;
	}
}
// PB <--

void SetTown2Nation(string town, int iNation)
{
        CaptureTownForNation(town, iNation);
        ChangeCitizenNation(town, iNation); // screwface
        Towns[GetTownIndex(town)].homeland = iNation;
}

void ChangeCitizenNation(string town, int iNation)
{
	for(int i=0; i<CHARACTERS_QUANTITY; i++)
	{
		ref curChar = GetCharacter(i);
		if(Checkattribute(curChar, "location") && GetTownIDFromLocID(curChar.location) == town) // && sti(curChar.nation) != iNation)
		{
			if (curchar.chr_ai.group == GetTownSoldierGroup(Town))
			{
				if(curchar.location == "Redmond_port") // Redmond gate guards were defined with names by default
				{
					curChar.old.name = "Soldier";
					curChar.old.lastname = "";
					curChar.name = TranslateString("","Soldier");
					curChar.lastname = "";
				}
				//FaceMaker(curchar); // Face icons should have been redone in the SetTownGarrisonForNation function ????
				continue;
			}
			if(Checkattribute(curChar, "nation.n0") || curChar.id == "Bertrand Ogeron") continue; //Governor
			curchar.nation = iNation;
			if(curChar.old.name != "smuggler" && curChar.old.name != "diplomat" && curChar.old.name != "Street")
			{
				SetRandomNameToCharacter(curchar);
			}
			if(HasSubStr(curChar.location, "store"))
			{
				Stores[GetCurrentStore(curChar.location)].owner = Getmyfullname(curChar);
			}

			LAi_group_MoveCharacter(curchar, GetCitizensName(iNation) + "_CITIZENS");

			switch(sti(curchar.nation))
			{
				case ENGLAND:
					if(Checkattribute(curChar, "greeting") && HasSubStr(curChar.greeting, "citizen"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_Redmond Citizen";
					}
					if(HasSubStr(curChar.location, "shipyard"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_Roger Murray";
					}
					if(HasSubStr(curChar.location, "store"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_John Filbert";
					}
					if(HasSubStr(curChar.location, "tavern") && !CheckAttribute(CurChar,"tavern")) // not the officiant
					{
						if(curChar.location.group == "merchant" || curChar.location.group == "barmen")
						{
							if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
							else curChar.greeting = "Gr_Olyver Littlejohn";
						}
					}
				break;
				case FRANCE:
					if(Checkattribute(curChar, "greeting") && HasSubStr(curChar.greeting, "citizen"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_French citizen";
						else curChar.greeting = "Gr_falaise de fleur citizen";
					}
					if(HasSubStr(curChar.location, "shipyard"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_French citizen";
						else curChar.greeting = "Gr_jean filaut";
					}
					if(HasSubStr(curChar.location, "store"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_French citizen";
						else curChar.greeting = "Gr_arnaud matton";
					}
					if(HasSubStr(curChar.location, "tavern") && !CheckAttribute(CurChar,"tavern")) // not the officiant
					{
						if(curChar.location.group == "merchant" || curChar.location.group == "barmen")
						{
							if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_French citizen";
							else curChar.greeting = "Gr_Albin Bonaventure";
						}
					}
				break;
				case SPAIN:
					if(Checkattribute(curChar, "greeting") && HasSubStr(curChar.greeting, "citizen"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_isla muelle citizen";
					}
					if(HasSubStr(curChar.location, "shipyard"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_esteban castillo";
					}
					if(HasSubStr(curChar.location, "store"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_Emiliano Rionda";
					}
					if(HasSubStr(curChar.location, "tavern") && !CheckAttribute(CurChar,"tavern")) // not the officiant
					{
						if(curChar.location.group == "merchant" || curChar.location.group == "barmen")
						{
							if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
							else curChar.greeting = "Gr_claudio burrieza";
						}
					}
				break;
				case PIRATE:
					if(Checkattribute(curChar, "greeting") && HasSubStr(curChar.greeting, "citizen"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_QC Citizen";
					}
					if(HasSubStr(curChar.location, "shipyard"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Desiree' Muerte";
						else curChar.greeting = "Gr_QC Citizen";
					}
					if(HasSubStr(curChar.location, "store"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Desiree' Muerte";
						else curChar.greeting = "Gr_Peter Blowhorn";
					}
					if(HasSubStr(curChar.location, "tavern") && !CheckAttribute(CurChar,"tavern")) // not the officiant
					{
						if(curChar.location.group == "merchant" || curChar.location.group == "barmen")
						{
							if(curchar.sex == "woman") curChar.greeting = "Gr_Ines Diaz";
							else curChar.greeting = "Gr_Mario Figuiera";
						}
					}
				break;
				case HOLLAND:
					if(Checkattribute(curChar, "greeting") && HasSubStr(curChar.greeting, "citizen"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_Dutch Citizen";
						else curChar.greeting = "Gr_Douwesen Citizen";
					}
					if(HasSubStr(curChar.location, "shipyard"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_Dutch Citizen";
						else curChar.greeting = "Gr_Lambrecht Fobes";
					}
					if(HasSubStr(curChar.location, "store"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_Dutch Citizen";
						else curChar.greeting = "Gr_Gheerlof Darlang";
					}
					if(HasSubStr(curChar.location, "tavern") && !CheckAttribute(CurChar,"tavern")) // not the officiant
					{
						if(curChar.location.group == "merchant" || curChar.location.group == "barmen")
						{
							if(curchar.sex == "woman") curChar.greeting = "Gr_Ines Diaz";
							else curChar.greeting = "Gr_Friedrich Corleis";
						}
					}
				break;
				case PORTUGAL:
					if(Checkattribute(curChar, "greeting") && HasSubStr(curChar.greeting, "citizen"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_Conceicao Citizen";
					}
					if(HasSubStr(curChar.location, "shipyard"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_Humberto de Paiva";
					}
					if(HasSubStr(curChar.location, "store"))
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_Martinho Guterres";
					}
					if(HasSubStr(curChar.location, "tavern") && !CheckAttribute(CurChar,"tavern")) // not the officiant
					{
						if(curChar.location.group == "merchant" || curChar.location.group == "barmen")
						{
							if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
							else curChar.greeting = "Gr_Duarte Correja";
						}
					}
				break;
				// default:
				if(Checkattribute(curChar, "greeting") && HasSubStr(curChar.greeting, "citizen"))
				{
					if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
					else curChar.greeting = "Gr_Oxbay Citizen";
				}
				if(HasSubStr(curChar.location, "shipyard"))
				{
					if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
					else curChar.greeting = "Gr_Oweyn McDorey";
				}
				if(HasSubStr(curChar.location, "store"))
				{
					if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
					else curChar.greeting = "Gr_Alan Milds";
				}
				if(HasSubStr(curChar.location, "tavern") && !CheckAttribute(CurChar,"tavern")) // not the officiant
				{
					if(curChar.location.group == "merchant" || curChar.location.group == "barmen")
					{
						if(curchar.sex == "woman") curChar.greeting = "Gr_Woman_English Citizen";
						else curChar.greeting = "Gr_Everard Gordon";
					}
				}
			}
		}

		if (isSoldier(curchar) > -1)
		{
			TakeItemFromCharacter(curchar, GetCharacterEquipByGroup(curchar, BLADE_ITEM_TYPE));
			TakeItemFromCharacter(curchar, GetCharacterEquipByGroup(curchar, GUN_ITEM_TYPE));

			//ARF change: sword equip depends on nation char (later periods) i always put the less rare swords
			if(GetCurrentPeriod() >= PERIOD_GOLDEN_AGE_OF_PIRACY)
			{
				switch(sti(curchar.nation))
				{
					case ENGLAND:
						GiveItem2Character(curchar, "blade39");//ARF: Gold Handled Naval Dirk, awesome looking (available from golden age of piracy)
					break;
					case FRANCE:
						GiveItem2Character(curchar, "blade3");//ARF: Badelaire (available in all periods but guards get later)
					break;
					case SPAIN:
						GiveItem2Character(curchar, "blade47");//ARF: Light Tizona (available in all periods but guards get later)
					break;
					case PORTUGAL:
						GiveItem2Character(curchar, "blade29");//ARF: Portuguese Officer's Sword (available in all periods but guards get later)
					break;
					case HOLLAND:
						GiveItem2Character(curchar, "blade26");//ARF: Solingen Rapier (available from spannish main but guards get later)
					break;
					case AMERICA:
						GiveItem2Character(curchar, "blade27");//ARF: Bosun's Choice {no faction} (available from golden age of piracy)
					break;
					case PIRATE:
						GiveItem2Character(curchar, "blade50");//ARF: Venetian Navy Cutlass {pirate sword} (available from golden age of piracy)
 					break;
					// default:
					GiveItem2Character(curchar, "blade36");//ARF: hunting sword (all periods available) only for "non regular" nation
				}
				GiveItem2Character(curchar, "pistolmket"); //musket for periods from golden age of piracy
				curchar.equip.gun   = "pistolmket";
				if (ENABLE_AMMOMOD) {
					TakenItems(curchar, "gunpowder", 1 + rand(2));
					TakenItems(curchar, "musketbullets", 1 + rand(1));
				}
			}
			//ARF: sword equip depends on nation char (for earlier period) i always put the less rare swords
			else
			{
				switch(sti(curchar.nation))
				{
					case ENGLAND:
						GiveItem2Character(curchar, "blade22");//ARF: Corsair's Pride (available all periods but guards get earlier)
					break;
					case FRANCE:
						GiveItem2Character(curchar, "blade9");//ARF: French Admiralty Rapier (not available after golden age of piracy)
					break;
					case SPAIN:
						GiveItem2Character(curchar, "blade16");//ARF: Tizona (not available after golden age of piracy)
					break;
					case PORTUGAL:
						GiveItem2Character(curchar, "blade15");//ARF: Iberian Longsword (not available after golden age of piracy)
					break;
					case HOLLAND:
						GiveItem2Character(curchar, "blade23");//ARF: Dutch Admiralty Sword (available all periods but guards get earlier)
					break;
					case AMERICA:
						GiveItem2Character(curchar, "blade10");//ARF: piranha {no faction} (not available after golden age of piracy anyway AMERICA doesnt exist early)
					break;
					case PIRATE:
						GiveItem2Character(curchar, "blade6");//ARF: Schiavona {pirate sword} (not available after colonial power)
					break;
					// default:
					GiveItem2Character(curchar, "blade36");//ARF: hunting sword (all periods available) only for "non regular" nation
				}
				GiveItem2Character(curchar, "pistol7"); //ARF: gave brace of small pistol for earlier periods
				curchar.equip.gun   = "pistol7";
				if (ENABLE_AMMOMOD) {
					TakenItems(curchar, "gunpowder", 1 + rand(2));
					TakenItems(curchar, "pistolbullets", 1 + rand(1));
				}
			}
			curchar.equip.blade = FindCharacterItemByGroup(curchar, BLADE_ITEM_TYPE);
		}
	}
}
